#extension GL_EXT_shader_texture_lod : require
#ifdef GL_ES  
precision mediump float;  
#endif  
varying lowp vec4 v_frontColor;
varying lowp vec2 TexCoordOut; // New
uniform lowp sampler2D Texture; // New
const float blurSize = 1.0/512.0; // I've chosen this size because this will result in that every step will be one pixel wide if the RTScene texture is of size 512x512

/* PASSTHROUGH*/
void main( void ) {  
   // need to figure out a way to actually determine the center
   // or pass in the calculation based on the stretched thing
   vec4 sum = vec4(0.0);
 
   // blur in y (vertical)
   // take nine samples, with the distance blurSize between them
   gl_FragColor = texture2D(Texture, TexCoordOut.st);
}


/*
SIN DISTORTION
	vec4 texColor = texture2D(Texture, vec2(TexCoordOut.s+cos(gl_FragCoord.y*0.1)*0.01, TexCoordOut.t+cos(gl_FragCoord.x*0.1)*0.01));
    gl_FragColor = vec4(texColor.g,texColor.b, texColor.r, 1.0);

*/

/*
V BLUR.
   vec4 sum = vec4(0.0);
 
   // blur in y (vertical)
   // take nine samples, with the distance blurSize between them
   sum += texture2D(Texture, vec2(TexCoordOut.x - 4.0*blurSize, TexCoordOut.y)) * 0.05;
   sum += texture2D(Texture, vec2(TexCoordOut.x - 3.0*blurSize, TexCoordOut.y)) * 0.09;
   sum += texture2D(Texture, vec2(TexCoordOut.x - 2.0*blurSize, TexCoordOut.y)) * 0.12;
   sum += texture2D(Texture, vec2(TexCoordOut.x - blurSize, TexCoordOut.y)) * 0.15;
   sum += texture2D(Texture, vec2(TexCoordOut.x, TexCoordOut.y)) * 0.16;
   sum += texture2D(Texture, vec2(TexCoordOut.x + blurSize, TexCoordOut.y)) * 0.15;
   sum += texture2D(Texture, vec2(TexCoordOut.x + 2.0*blurSize, TexCoordOut.y)) * 0.12;
   sum += texture2D(Texture, vec2(TexCoordOut.x + 3.0*blurSize, TexCoordOut.y)) * 0.09;
   sum += texture2D(Texture, vec2(TexCoordOut.x + 4.0*blurSize, TexCoordOut.y)) * 0.05;

*/
/* KALIDASCOPE

varying vec2 TexCoordOut;
varying vec2 texdim0;
uniform vec2 size = {0.5, 0.5};
uniform vec2 scale = {0.5, 0.5};
uniform vec2 offset = {0.2, 0.2};
uniform vec2 origin = {0,0};
uniform float div = 1.;  
uniform sampler2DRect Texture;
const float pi=3.1415926;

void main(void){
   // where is the point?
   vec2 point = abs(mod((TexCoordOut*scale)/texdim0+origin,1.));

   // cartesian to polar conversion
   vec2 dt = point-0.5;
   float radius = sqrt(dot(dt,dt)); //hypot
   float theta = atan(dt.y,dt.x)+pi;
   float phi = 2.*pi/div;

   // fold theta in the range 0-phi
   float modtheta = mod(abs(theta),phi*2.);
   float foldtheta = phi-abs(modtheta-phi);
   
   // the above is equivalent to the following, but uses less instructions
   //float foldtheta = mix(mod(theta,phi),phi-mod(theta,phi),floor(mod(theta,phi*2.)/phi));

   // polar to cartesian conversion
   vec2 no = vec2(-cos(foldtheta)*radius, -sin(foldtheta)*radius);   
   no = (no+0.5)*texdim0;

   // fold x and y in the range 0-size
   vec2 off = abs(no+offset*texdim0);
   vec2 modoff = mod(off,texdim0*2.);
   vec2 fold = texdim0-abs(modoff-texdim0);

   // the above is equivalent to the following, but uses less instructions
   //vec2 fold = mix(mod(off,texdim0),texdim0-mod(off,texdim0),floor(mod(off,texdim0*2.)/texdim0));
   
   // output texture
   gl_FragColor = texture2DRect(Texture,fold);

}
 */