toneCount = 0
-- mute = true
BPoint = class(CenteredObject, function(o, x, y, parent)
	CenteredObject.init(o, x, y, 40*r_scale, 10*r_scale)
	o:setup(x, y, parent)
end)
function BPoint:setup(x, y, parent)
	local o = self
	o.sprite = sprites['ui']['circle.png']
	o.scale = 0.1
	o.parent = parent
	o.pulses = {}
	o.pulseCool = 0
	o.pulseGraphic = CenteredObject(x, y, 20, 20)
	o.pulseGraphic.sprite = sprites['ui']['circle.png']
	o.pulseGraphic.scale = 0.1
	o.pulseGraphic:setColor(200, 140+math.random()*30, 220, 200)
	local pNotes = {0, 3, 5, 7, 8, 0+12, 3+12, 5+12, 7+12, 8+12}
	o.note = pNotes[math.random(1, #pNotes)]-24
	o.lastPos = {}
	o.fingerDown = {}
	o.fingerCount = 0

	o.touchDown = DragArea.touchDown
	o.touchMoved = DragArea.touchMoved
	o.touchUp = DragArea.touchUp
	-- o.onMove = function(da, x, y, id)
	-- 	p = Vec2(x, y)
	-- 	p:sub(da.lastPos[id])
	-- 	self.pos:add(p)
	-- 	self.pulseGraphic.pos:add(p)
	-- end
end
function BPoint:pulse(pulseTime)
	table.insert(self.pulses, pulseTime)
end
function BPoint:update()
	for i,v in pairs(self.pulses) do
		if v < 0 then
			self.pulses[i] = nil
		elseif v == 0 and not self.pulsing then
			self.pulses[i] = nil
			toneCount = (toneCount+1)%10
			local test = StackContainerInstance():getTone(toneCount)
			for i=0,15 do
				test:setNop(i)
			end
			local op = 0
			local nn = function()
				op = op+1
				return op-1
			end
			-- calc panning
			local angleToPellet = math.deg(self.parent.parent.ship.pos:copy():sub(self.pos):normalize():angle())
			angleToPellet = -angleToPellet%360
			local panning = 0
			if angleToPellet > 180 then
				panning = (1-(angleToPellet-180)/180)
			else
				panning = -1*(1-(angleToPellet)/180)
			end

			if not mute then
				test:setOsc(nn(), 1)
				test:setOsc(nn(), 1, 0.1)
				test:setMaths(nn(), 3)
				test:setEnv(nn(), .03, 0.1)
				test:setMaths(nn(), 2)
				test:setFilter(nn(), 0.2)
				test:setDelay(nn(), .6*22050, 0.3, 1)
				test:setOut(nn(), 1.0, panning)
				test:trigger(self.note)
				test:off()
			end
			self.pulseGraphic.scale = 0.1
			self.pulseGraphic:setColor(200, 140, 220, 200)
			self.pulsing = true
			self:calcTriggers()
			break;
		else
			self.pulses[i] = v-1
		end
	end
	if self.pulsing then
		self.pulseGraphic.scale = self.pulseGraphic.scale+0.03
		self.pulseGraphic.tint.a = math.max(self.pulseGraphic.tint.a - 3, 0)
		if self.pulseGraphic.tint.a == 0 then
			self.pulsing = false
		end
	end
end
function BPoint:draw()
	self.pulseGraphic:draw()
	CenteredObject.draw(self)
end
function BPoint:calcTriggers()
	for i,v in ipairs(self.parent.bloomers.members) do
		if v~=self then	
			local d = self.pos:distance(v.pos)
			local frameDistance = math.ceil(d/(0.03*self.sprite:getWidth()))
			local maxFrames = math.floor(255/8)
			if frameDistance < maxFrames then
				v:pulse(frameDistance)
			end
		end
	end
end
function BPoint:setPosition(x, y)
	Object.setPosition(self, x, y)
	if self.pulseGraphic then
		self.pulseGraphic:setPosition(x, y)
	end
end
Bloomer = class(Group, function(o, parent)
	Group.init(o)
	o.parent = parent
	o:setup()
end)

function Bloomer:setup()
	local o = self
	-- drop a bunch of points
	self.bloomers = self:add(Group())
	for i=1,100 do
		local b = self.bloomers:add(BPoint(math.random()*self.parent.worldMult*WORLDSIZE/4-self.parent.worldMult*WORLDSIZE/8+self.parent.ship.pos.x, (math.random()*self.parent.worldMult*WORLDSIZE/4)+self.parent.worldMult*WORLDSIZE/2, self))
		-- local b = self.bloomers:add(BPoint(math.random()*100+self.parent.ship.pos.x, math.random()*100+self.parent.ship.pos.y, self))
		local x, y = round(b.pos.x/self.parent.worldMult), round(b.pos.y/self.parent.worldMult)
		b.forceDraw = true
		local empty = self.parent:findEmpty(x, y)
		if empty[1] then
			b:setPosition(empty[2]*o.parent.worldMult, empty[3]*o.parent.worldMult)
			print(empty[2], empty[3])
		end
	end
	self.bloomers.members[1]:setPosition(self.parent.worldMult*WORLDSIZE/2, self.parent.worldMult*WORLDSIZE/2)
	local b = self.bloomers.members[1]
	local x, y = round(b.pos.x/self.parent.worldMult), round(b.pos.y/self.parent.worldMult)
	local empty = self.parent:findEmpty(x, y)
	if empty[1] then
		b:setPosition(empty[2]*o.parent.worldMult, empty[3]*o.parent.worldMult)
		print(empty[2], empty[3])
	end

	bludG.camera.scroll = Vec2(0,0)
	self.triggerTime = 200
	self.nextTrigger = self.triggerTime
	self.triggerCount = 0

	self:addToggle(0,0,self.pickup)
	self:addToggle(50*r_scale,0,self.drop)
	
	self.ship = self.parent.ship
	
	self.line = self:add(PlayerLine(self.ship.pos, self.ship.pos))
	self.line.sprite = sprites['ui']['circle.png']
	self.line:setColor(100, 255, 150)
	self.line.w = 2*r_scale
end

function Bloomer:addToggle(x, y, fn)
	local o = self
	local toggleButton = o:add(DragArea(x,y,40*r_scale, 80*r_scale))
	toggleButton.sprite = sprites['ui']['white.png']
	toggleButton.drawType = 'stretched'
	toggleButton.onStart = function()
		if toggleButton.fingerCount == 1 then
			fn(self)
			toggleButton:setColor(200, 240, 220, 100)
		end
	end
	toggleButton.onPress = function()
		toggleButton:setColor(120, 180, 160, 100)
	end
	toggleButton:setColor(120, 180, 160, 100)
	toggleButton.scrollFactor = Vec2(0,0)
end
function Bloomer:drop()
	if self.ship.storage and self.ship.storage[#self.ship.storage] then
		-- take the pulser out of storage and put it in the world
		local b = self.bloomers:add(self.ship.storage[#self.ship.storage])
		b:setPosition(self.ship.pos.x, self.ship.pos.y)
		table.remove(self.ship.storage, #self.ship.storage)
	end
end
function Bloomer:panModeHandler(da, x, y, id)
	local p = Vec2(x, y)
	p:sub(da.lastPos[id])
	self.ship.velocity:add(p)
end
function Bloomer:pickup()
	print('pickingup')
	local n, dist = findNearest(self.bloomers.members, self.ship.pos)
	if dist < 70*r_scale then
		if not self.ship.storage then self.ship.storage = {} end
		-- can't pick up the first bloomer
		if n ~= self.bloomers.members[1] then
			-- remove the pulser from the world and add it to the ships storage
			table.insert(self.ship.storage, n)
			self.bloomers:remove(n)
		end
	end
end

function Bloomer:update()
	self.nextTrigger = self.nextTrigger-1
	if self.nextTrigger == 0 then
		self.nextTrigger = self.triggerTime
		-- trigger the core object
		self.bloomers.members[1]:pulse(0)
	end
	Group.update(self)
	self.ship.velocity:mult(0.99)
	-- determine the nearest flower, and allow the player to pick it up
	local n, dist = findNearest(self.bloomers.members, self.ship.pos)
	if dist < 70*r_scale then
		self.line.b = Vec2(n.pos.x, n.pos.y)
	else
		self.line.b.x, self.line.b.y = self.ship.pos.x, self.ship.pos.y
	end

end
-- mainState = WrapperState(Group());
-- mainState:changeState(Bloomer())