function HSVtoRGB(h, s, v)

  local r, g, b

  local i = math.floor(h * 6)
  local f = h * 6 - i
  local p = v * (1 - s)
  local q = v * (1 - f * s)
  local t = v * (1 - (1 - f) * s)

  local switch = i % 6
  if switch == 0 then
    r = v g = t b = p
  elseif switch == 1 then
    r = q g = v b = p
  elseif switch == 2 then
    r = p g = v b = t
  elseif switch == 3 then
    r = p g = q b = v
  elseif switch == 4 then
    r = t g = p b = v
  elseif switch == 5 then
    r = v g = p b = q
  end

  return math.floor(r*255), math.floor(g*255), math.floor(b*255)
  
end

RTPGameOver = class(Group, function(o, substate)
	Group.init(o)
	o:add(substate)
	o.background = o:add(GradientObject(0,0,bludG.camera.w, bludG.camera.h, bludColor(0,0,0), bludColor(0,255,50)))
	o.background.scrollFactor = Vec2(0,0)
	o.title = o:add(StringObject(0,0,"GAME OVER"))
	o.title:setScrollFactor(Vec2(0,0))
	o.title:setPosition(bludG.camera.w/2-o.title.w/2, bludG.camera.h/2-o.title.h/2-100*r_scale)

	o.subtitle = o:add(StringObject(0,0,"tap to restart", nil, 0.5))
	o.subtitle:setScrollFactor(Vec2(0,0))
	o.subtitle:setPosition(bludG.camera.w/2-o.subtitle.w/2, bludG.camera.h/2-o.subtitle.h/2)
end)
function RTPGameOver:update()
	Group.update(self)
	local r, g, b = HSVtoRGB((bludG.last_t+0.1)/2.0, 0.4, 0.7)
	self.background.tintTop = {r=r, g=g, b=b, a=0.5}
	r, g, b = HSVtoRGB((bludG.last_t+0.5)/2.0, 0.1, 0.5)
	self.background.tintBottom = {r=r, g=g, b=b, a=0.5}
end
function RTPGameOver:touchDown()
	mainState = WrapperState(Group());
	mainState:changeState(RememberThePillar())
end

