BTDObj = class(Object, function(o, x, y, w, h)
	Object.init(o, x, y, w, h)
	if box2d then
		o.b2d = BludBox2dRect(box2d, o.pos.x+o.w/2, o.pos.y+o.h/2, o.w/2, o.h/2, 1, 0.4, 0.4, true)
		o.b2d:setData(o)
	end
end)
function BTDObj:update()
	Object.update(self)
	if self.b2d then
		if self.alive then
			self.b2d:setPosition(self.pos.x+self.w/2, self.pos.y+self.h/2)
		elseif self.killb2d then
			self.b2d:destroy();
			self.killb2d = false;
		end
	end
end
-- contains a set of objects that can kill the player
RTPPillar = class(Group, function(o, x, y)
	local s_size = 5
	o.s_size = s_size
	Group.init(o)
	o.body = o:add(Group())
	o.head = o.body:add(BTDObj(x, y, s_size, s_size))
	o.head.sprite = sprites['tiles']['circle.png']
	o.head.drawType = 'stretched'
	o.head.killer = true
	o.head:setColor(0,255,0)
	o.head.moves = true
	for i=1,20 do	
		local b = o.body:add(BTDObj(x, y-i*s_size, s_size, s_size))
		b.sprite = sprites['tiles']['circle.png']
		b.drawType = 'stretched'
		b.killer = true
		b:setColor(0,255,0)
	end
end)
function RTPPillar:update()
	-- move the head forward
	local dir = Vec2(math.cos(bludG.last_t*2), math.sin(bludG.last_t*1.5)*1.5)
	dir:mult(100)
	self.head.acceleration = dir
	Group.update(self)
	-- bounce the head off the walls if it hit

	if self.head.pos.x < 0 then self.head.pos.x = 0; self.head.velocity.x = self.head.velocity.x * -1 end
	if self.head.pos.x > bludG.camera.w then self.head.pos.x = bludG.camera.w; self.head.velocity.x = self.head.velocity.x * -1 end
	if self.head.pos.y < 0 then self.head.pos.y = 0; self.head.velocity.y = self.head.velocity.y * -1 end
	if self.head.pos.y > bludG.camera.h then self.head.pos.y = bludG.camera.h; self.head.velocity.y = self.head.velocity.y * -1 end
	for i,v in ipairs(self.body.members) do
		if v ~= self.head then
			local p = v.pos:copy():sub(self.body.members[i-1].pos):normalize():mult(self.s_size)
			v.pos = self.body.members[i-1].pos:copy():add(p)
		end
	end
end