RememberThePillar = class(Group, function(o)
	Group.init(o)
	o:setup()
end)
function RememberThePillar:setup()
	self:setupBox2d()
	local xGrid = 10
	local yGrid = 15
	self.grid = self:add(Group())
	for x=0,xGrid do
		for y=0,yGrid do
			local g = self.grid:add(Object(x*bludG.camera.w/xGrid, y*bludG.camera.h/yGrid, bludG.camera.w/xGrid, bludG.camera.h/yGrid))
			g.sprite = sprites['tiles']['white.png']
			g.drawType = 'stretched'
			g:setColor(20,30,40)
			g.triggers = {}
		end
	end
	bludG.camera.scroll = Vec2(0,0)
	self.ship = self:add(RTPShip(bludG.camera.w/2, bludG.camera.h/3*2))	
	self.pillar = self:add(RTPPillar(bludG.camera.w/2, bludG.camera.h/4))
	self.triggerTime = 20
	self.nextTrigger = self.triggerTime
	self.triggerCount = 0
	-- add the underlying grid
end
function RememberThePillar:update()
	Group.update(self)
	self.nextTrigger = self.nextTrigger-1
	if self.nextTrigger == 0 then
		self.triggerCount = (self.triggerCount+1)%16
		self.nextTrigger = self.triggerTime
		-- add the trigger to where the player is
		self.grid:overlap(self.ship, function(a, b)
			a.triggers[self.triggerCount] = 1
		end)
		self.grid:overlap(self.pillar.body, function(a, b)
			a.triggers[self.triggerCount] = 2
		end)
		local p, e = 0, 0
		for i,v in ipairs(self.grid.members) do
			if v.triggers[self.triggerCount] then
				if v.ct then v.ct = Tweener:removeTween(v.ct) end
				if v.triggers[self.triggerCount] == 1 then
					p = p+1
					v:setColor(200, 200, 200)
				elseif v.triggers[self.triggerCount] == 2 then
					e = e+1
					v:setColor(100*0.2, 255*0.2, 100*0.2)
				end
				v.ct = Tweener:addTween(v.tint, {r=20, g=30, b=40}, {time=2})
			end
		end
			local test = StackContainerInstance():getTone(self.triggerCount%8)
		if (p-e)%2==0 then
			-- trigger the bullets
			test:setOsc(0, 0)
			test:setOsc(1, 0, 0.1)
			test:setMaths(2, 3)
			test:setEnv(3, 1.1, 0.9)
		else
			test:setOsc(0, 2)
			test:setOsc(1, 0, 1)
			test:setMaths(2, 3)
			test:setEnv(3, .01, 0.1)
		end
		test:setMaths(7, 2)
		test:setFilter(8, 0.5)
		test:setOut(9)
		test:trigger(p-e)
		test:off()	
	end
end
function RememberThePillar:setupBox2d()
	-- setup box2d so that it can be used for all the collisions in the game
	if not bhComponentManager then
		bhComponentManager = bludComponentManager()
	end
	if box2d then
		bhComponentManager:removeComponent(box2d)
	end
	box2d = BludBox2d();
	bhComponentManager:addComponent(box2d)
	box2d:setStartCallback(function(a, b)
		self:collisionStarted(a, b)
	end)
	box2d:setEndCallback(function(a, b)
		self:collisionEnded(a, b)
	end)
end
function RememberThePillar:collisionStarted(a, b)
	if type(a) == 'table' and a.handleCollision then a:handleCollision(b) end
	if type(b) == 'table' and b.handleCollision then b:handleCollision(a) end
end
function RememberThePillar:collisionEnded(a, b)
	if type(a) == 'table' and a.handleCollisionEnd then a:handleCollisionEnd(b) end
	if type(b) == 'table' and b.handleCollisionEnd then b:handleCollisionEnd(a) end
end

-- mainState = WrapperState(Group());
-- mainState:changeState(RememberThePillar())