
-- secret spot

SecretSnakePlayState = class(Group, function(o)
	Group.init(o)
	o:setup()
end)
function SecretSnakePlayState:setup()
	local o = self
	o.background = o:add(GradientObject(0,0,bludG.camera.w, bludG.camera.h, bludColor(0,0,0), bludColor(0,255,50)))
	-- o.background:setColor(0,255,50)
	o.background.scrollFactor = Vec2(0,0)
	-- o.background.sprite = sprites['tiles']['white.png']
	-- o.background.drawType = 'stretched'
	o.title = o:add(StringObject(0,0,"SECRET SOUND"))
	o.title:setScrollFactor(Vec2(0,0))
	o.title:setPosition(bludG.camera.w/2-o.title.w/2, bludG.camera.h/2-o.title.h/2-100*r_scale)

	o.subtitle = o:add(StringObject(0,0,"find the sound", nil, 0.5))
	o.subtitle:setScrollFactor(Vec2(0,0))
	o.subtitle:setPosition(bludG.camera.w/2-o.subtitle.w/2, bludG.camera.h/2-o.subtitle.h/2)


	o.playerPosition = Vec2(0,0)
	o.playerDirection = Vec2(1,0):normalize()
	o.playerDirection:rotate(math.rad(math.random(-10,10)*90))
	o.pelletPosition = Vec2(math.random(-10, 10), math.random(-10, 10))

	o.triggerTime = 100
	o.nextTrigger = o.triggerTime

	o.left = o:add(FancyButton(0,bludG.camera.h-40*r_scale,bludG.camera.w/3, 40*r_scale, "turn left"))
	o.left.onPress = function()
		o.playerDirection:rotate(math.rad(-90))
		return false
	end
	o.left.scrollFactor = Vec2(0,0)
	o.left:setPosition(0,bludG.camera.h-40*r_scale)
	o.forward = o:add(FancyButton(bludG.camera.w/3,bludG.camera.h-40*r_scale,bludG.camera.w/3, 40*r_scale, "forward"))
	o.forward.onPress = function()
		o.playerPosition:add(o.playerDirection)
		return false
	end
	o.forward.scrollFactor = Vec2(0,0)
	o.forward.scrollFactor = Vec2(0,0)

	o.right = o:add(FancyButton(bludG.camera.w/3*2,bludG.camera.h-40*r_scale,bludG.camera.w/3, 40*r_scale, "turn right"))
	o.right.onPress = function()
		o.playerDirection:rotate(math.rad(90))
		return false
	end
	o.right.scrollFactor = Vec2(0,0)
	o.right.scrollFactor = Vec2(0,0)

	bludG.camera.scroll = Vec2(-10*10, -10*10)
	o.gameOver = false
end
function SecretSnakePlayState:update()
	self.nextTrigger = self.nextTrigger-1
	if self.nextTrigger == 0 then
		self.nextTrigger = self.triggerTime
		-- calculate the direction to the pellet from the player
		local angleToPellet = math.deg(self.playerPosition:copy():sub(self.pelletPosition):normalize():angle())
		local distanceToPellet = self.playerPosition:distance(self.pelletPosition)
		local playerAngle = math.deg(self.playerDirection:angle())
		playerAngle = (playerAngle-angleToPellet)%360
		local panning = 0
		if playerAngle > 180 then
			panning = (1-(playerAngle-180)/180)
		else
			panning = -1*(1-(playerAngle)/180)
		end
		local volume = 1/math.pow(2, distanceToPellet/5)
		-- local volume = 1
		-- panning = 0
		if distanceToPellet < 1 then
			if not self.gameOver then
				self.subtitle:setValue("you found the sound")
				self.subtitle:setPosition(bludG.camera.w/2-self.subtitle.w/2, bludG.camera.h/2-self.subtitle.h/2)
				self.instructions = self:add(StringObject(0,0,"tap to restart", nil, 0.5))
				self.instructions:setScrollFactor(Vec2(0,0))
				self.instructions:setPosition(bludG.camera.w/2-self.instructions.w/2, bludG.camera.h/2+self.instructions.h*2)

				self.gameOver = true
			end
			panning = 0
			SoundContainerInstance():addTone(440, -25, 1, panning, 2.2, volume*2)
			SoundContainerInstance():addTone(440, -25, 0, panning, 5.2, volume*2)
		end
		SoundContainerInstance():addTone(440, -10, 1, panning, 0.9, volume*2)
		SoundContainerInstance():addTone(440, -13, 1, panning, 0.9, volume*2)
	end
end
function SecretSnakePlayState:touchDown(x, y, id)
	if self.gameOver then
		mainState = WrapperState(Group());
		mainState:changeState(SecretSnakePlayState())
	end
	Group.touchDown(self, x, y, id)
end
function SecretSnakePlayState:draw()
	local o = CenteredObject(self.playerPosition.x*10*r_scale, self.playerPosition.y*10*r_scale, 10*r_scale, 10*r_scale)
	o.sprite = sprites['tiles']['bellhop_1.png']
	o.rot = 180-math.deg(self.playerDirection:angle())
	o:draw()
	o:setColor(10, 200, 100)
	o:setPosition(self.pelletPosition.x*10, self.pelletPosition.y*10)
	o:draw()
	Group.draw(self)
end