svg_root = "badHotel_/assets/svg_assets/"
draworder = {}
fs = PFileSystem();

keyPressSubs = {}
function blud.key.pressedSubscribe(fn, object)
  table.insert(keyPressSubs, {fn, object})
end

-- yay, hack!
runningCoroutines = {};

-- utility for getting around tables
function findNode(rootNode, name)
  if rootNode.name == name then
    return rootNode
  else
    if type(rootNode) == "table" then
      for i, v in ipairs(rootNode) do
        found = findNode(v, name)
        if(found ~= false) then
          return found
        end
      end
    end
  end
  return false
end

bg = bludGraphics();
bg:setBackground(0, 0, 0)
local loadStart = os.time()
r_scale = 1
ipad = ''
if bg:getHeight() > 320 then
  r_scale = 2
end
if bg:getHeight() > 640 then
  ipad = '_ipad'
elseif bg:getWidth() > 960 then
  ipad = '_ip5'
end
if bg:getHeight() > 768 then
  r_scale = 4
end

if bg:getHeight() > 320 then
  retina = true
end

dofile(blud.bundle_root .. "/badHotel_/imports.lua")

print("imports load time: ", os.time() - loadStart)



sheetsToLoad = {{name="bg", t='png'}, {name="ui", t='png'}, {name="additive", t='png'}}
sheets = {}
sprites = {}

function loadSprites()
  spriteLoader = dofile(blud.bundle_root ..  "/badHotel_/setupSprites.lua")
  -- player.currentWorld = worlds[1]
  -- PlayState.setupUnderBg()
  for i,v in ipairs(sheetsToLoad) do
    sheets[v.name], sprites[v.name] = spriteLoader(v.name, v.t)
    if v.name == 'bg' then
      sheets[v.name]:setAlpha(false)
    end
    if v.t == 'png' then
      sheets[v.name]:setBlendMode(1)
    end
    if v.name == 'additive' then
      sheets[v.name]:setBlendMode(2)
    end
  end
  mainbg = {}
  -- setup the circle used for anti aliasing
  local svgObject = ObjectGroup()
  svgObject:setSheet(sheets['bg'])
  svgObject:setCircle(sprites['bg']['white.png'])
end

function playEffect(effect)
  pd:startList("fromOF")
  pd:addSymbol("sounds")
  pd:addSymbol(effect)
  pd:finish()
end
function playEffectNew(effect, ...)
    pd:startList("fromOF")
    pd:addSymbol(effect)
    pd:addFloat(0)
    pd:finish()
end
function math.randomRange(min, max)
  return min + (math.random() * (max - min))
end
function math.round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

circle = bludImage()
circle:load(blud.bundle_root .. "/badHotel_/assets/circle.png")
line = bludLine(circle, 2);
LineBatch = class(function(o)
  o:clear()
  o.r = 0
  o.g = 0
  o.b = 0
end)
function LineBatch:setColor(r, g, b)
  self.r = r
  self.g = g
  self.b = b
end
function LineBatch:clear()
  self.batch = {}
end
function LineBatch:addLine(x1, y1, x2, y2)
  table.insert(self.batch, {x1=x1, y1=y1, x2=x2, y2=y2})
end
function LineBatch:draw()
  bg:setColor(self.r, self.g, self.b)
  for i, v in pairs(self.batch) do
    line:drawLine(v.x1, v.y1, v.x2, v.y2)
  end
end
lb = LineBatch();

TextBatch = class(LineBatch, function(o)
  LineBatch.init(o)
  o.smallBatch = {}
end)
function TextBatch:clear()
  LineBatch.clear(self)
  self.smallBatch = {}
end

function TextBatch:addText(output, x, y, ...)
  local arg = {...}
  small = arg[1]
  width = arg[2]
  line_height = arg[3]
  if small then
    table.insert(self.smallBatch, {output=output, x=x, y=y, r=self.r, g=self.g, b=self.b, w=width, line_height=line_height})
  else
    table.insert(self.batch, {output=output, x=x, y=y, r=self.r, g=self.g, b=self.b, w=width, line_height=line_height})
  end
end

function TextBatch:draw()
  for i, v in pairs(self.batch) do
    bg:setColor(v.r, v.g, v.b)
  end
  for i, v in pairs(self.smallBatch) do
    bg:setColor(v.r, v.g, v.b)
  end
end
function TextBatch:getHeight(text, width, lh, ...)
  local arg = {...}
  small = arg[1]
  if small then
  else
  end
  return nil
end
tb = TextBatch();


PI = 3.14159265
DEG_TO_RAD = 1/360*2*PI

-- reverse pacman
-- system data structure
--    * grid size
-- level data structure
--    * all below have 
--      * position (Vec2)
--      * velocity (Vec2)
--      * moveTo(Vec2)
--    * enemies
--    * players
--    * pellets
--    * goals

function lerp(start, stop, amt)
  return start + (stop-start) * amt;
end
if bludG == nil then
  bludG = bludGlobal()
  -- bludG:startRecording()
end
sounds = SoundBank()
bb = bludShapeBatch(2000, 2);
bbt = bludShapeBatch(2000, 2);

particles = ParticleSystems();


output = ""

score = 0

heightGridSize = 17


if pd == nil then
  pd = bludPd();
  local pdCount = 0
  pd.updateCallback = function()
    if pd:getBangs() > 0 then
      if mainState and mainState.substate and mainState.substate.sync then mainState.substate:sync() end
    end
    pd:clearBangs()
  end
end
local gknogc = {}
function connectToGameKit()
  gk = bludGK();
  gk:connect(function()
    print('connected to gamekit')
    gk:getHashedId()
    -- connect to a parse user for this gamekit identity
    -- first attempt to find a gk user, and if not found, then build one
    local pquery = bludParseQuery("gkUser")
    pquery:whereKeyEquals("userId", gk:getId())
    gknogc[pquery]=pquery
    pquery:findObjects(function(objects)
      if not objects then 
        -- couldn't get a response to the query for whatever reason
        print('couldn\'t get user object')
      elseif #objects == 0 then
        local pobj = bludParseObject("gkUser")
        gknogc[pobj]=pobj
        -- should determine if there are any existing levels with this name and username yet
        pobj:setObject(gk:getAlias(), "userAlias")
        pobj:setObject(gk:getId(), "userId")
        pobj:save(function(saved, errorCode)
          -- should probably cache the score locally and reattempt to send if this fails later
          gknogc[pobj]=nil
          pgkuser = pobj
        end)
      else
        pgkuser = objects[1]      
      end
      gknogc[pquery]=nil
      if player then
        player:updateServerHighscore()
      end
    end)
  end);
end

function drawRect(x, y, w, h, r, g, b)
  local c = {x, y, w, h}
  if not retina then for i,v in ipairs(c) do c[i] = v/2 end end
  local tl = {c[1], c[2]}
  local tr = {c[1]+c[3], c[2]}
  local bl = {c[1], c[2]+c[4]}
  local br = {c[1]+c[3], c[2]+c[4]}
  sheet:addCornerTile(sprites['tile']["white.png"], tl[1],tl[2], tr[1],tr[2], br[1],br[2], bl[1],bl[2], 4, r,g,b,255)
end
function gridQuantize(x, y)
  x = math.floor(x/hgridSize)*hgridSize
  y = math.floor(y/vgridSize)*vgridSize
  return x, y
end

if not analytics and bludAnalytics then
  analytics = bludAnalytics()
end
loadSprites();
render = bludRenderer();
render:setSpriteSheet(sheets['bg'])
render:setSpriteSheet(sheets['ui'])
render:setSpriteSheet(sheets['additive'])

player = PlayerModel();
if bludGK then
  connectToGameKit()
end

saveData = persistence.load(blud.doc_root .. "/storage.lua");
if saveData then
  player:loadFrom(saveData)
end

if not true and not storekit and bludSK then
  completeTransaction = function(completed, successful)
    -- if the transaction isn't successful then either the user canceled, or they got an alert. either way, cancel the processing
    PurchaseProcessing = false
    if not successful then
        return nil
    end
    -- should give back the id for the purchased item
    -- unlock the number of levels that were just requested from storekit
    print(completed)
    -- todo attempt to store this information on the server
    player.serverSlots = player.serverSlots+StoreKitLevelUnlocks[completed]
    player:save()
  end
  storekit = bludSK(function(completed, successful)
    completeTransaction(completed, successful)
  end);
end

mainState = WrapperState(Group());
mainState:changeState(ModeMenu())
-- mainState:changeState(TurnShotState())

includeOsc = true
if oscRec == nil and includeOsc then
  oscRec = Receiver();
  oscSender = bludOsc();
  oscSender:setup("localhost", 9002)
  oscPrint = function(s)
    local m = bludOscMessage();
    m:setAddress("/print")
    m:addStringArg(s)
    oscSender:sendMessage(m)
  end
end


function blud.draw()
  if mainbg then
    for i,v in ipairs(mainbg) do
      local x, y = mainState.substate.bg_scrollx,0
      if not x then
        x, y = bludG.camera.scroll.x, bludG.camera.scroll.y
      end
      v:draw(x, y)
    end
  end
  if not webview then
    mainState:draw();
    bludG:draw();
    -- bb:draw();
  end
  if not webview then
    bbt:draw();
    particles:draw()
  end
end
function blud.update(t)
  if oscRec then
    oscRec:update();
  end
  for i,v in pairs(sheets) do
    v:clear()
  end
  if not webview then
    if needsVideoRemove then
      videoCompleteRemove()
      needsVideoRemove = false
    end
    Tweener:update();
    -- bb:clear();
    bbt:clear();
    lb:clear();
    tb:clear();
    for i,v in ipairs(sheetsToLoad) do
      if sheets[v] then
        sheets[v]:update(t)
      end
    end
    mainState:update();
    bludG:update(t);
    particles:update()
    pd.updateCallback()
  end
  for i=table.maxn(runningCoroutines),1,-1 do
    local v = runningCoroutines[i]
    if coroutine.status(v) == 'suspended' then
      print('resuming')
      print(coroutine.resume(v))
    elseif coroutine.status(v) == 'dead' then
      table.remove(runningCoroutines, i);
    end
  end
end
-- the mouse doubles these functions, so we don't need both
function blud.touch.down(x, y, id)
  mainState:touchDown(x, y, id)
  bludG:touchDown(x, y, id)
end
function blud.touch.moved(x, y, id)
  mainState:touchMoved(x, y, id)
  bludG:touchMoved(x, y, id)
end
function blud.touch.up(x, y, id)
  mainState:touchUp(x, y, id)
  bludG:touchUp(x, y, id)
end
function blud.mouse.pressed(x, y, id)
  mainState:touchDown(x, y, id)
  bludG:touchDown(x, y, id)
end
function blud.mouse.moved(x, y, id)
  if mainState.mouseMoved then
    mainState:mouseMoved(x, y, id)
    bludG:mouseMoved(x, y, id)
  end
end
function blud.mouse.dragged(x, y, id)
  mainState:touchMoved(x, y, id)
  bludG:touchMoved(x, y, id)
end
function blud.mouse.released(x, y, id)
  mainState:touchUp(x, y, id)
  bludG:touchUp(x, y, id)
end
function blud.dropped(file)
  mainState:changeState(SvgTestState(file))
end
function blud.gotFocus()
  bludG.last_t = bg:getMillis()/1000
end
function blud.exit()
  player:save()
end
function blud.key.pressed(key)
  mainState:keyPressed(key)
 -- do nothing when initially launching
 for i,v in ipairs(keyPressSubs) do
   v[1](v[2], key)
 end
end
function blud.key.released(key)
  mainState:keyReleased(key)
 -- do nothing when initially launching
 for i,v in ipairs(keyPressSubs) do
   v[1](v[2], key)
 end
end
-- seed the thing
math.randomseed(bludG:seedRandom())