function HSVtoRGB(h, s, v)

  local r, g, b

  local i = math.floor(h * 6)
  local f = h * 6 - i
  local p = v * (1 - s)
  local q = v * (1 - f * s)
  local t = v * (1 - (1 - f) * s)

  local switch = i % 6
  if switch == 0 then
    r = v g = t b = p
  elseif switch == 1 then
    r = q g = v b = p
  elseif switch == 2 then
    r = p g = v b = t
  elseif switch == 3 then
    r = p g = q b = v
  elseif switch == 4 then
    r = t g = p b = v
  elseif switch == 5 then
    r = v g = p b = q
  end

  return math.floor(r*255), math.floor(g*255), math.floor(b*255)
  
end

-- the bblock is made up of blocks!
BBlock = class(Object, function(o, x, y)
	local th, bh = math.random(), math.random()
	local mh = (th+bh)*0.5
	local tr, tg, tb = HSVtoRGB(th, 1, 1.9)
	local mr, mg, mb = HSVtoRGB(mh, 1, 1.9)
	local br, bg, bb = HSVtoRGB(bh, 1, 1.9)
	local colors = {{tr, tg, tb}, {mr, mg, mb}, {br, bg, bb}}
	Object.init(o, x, y, gridSize*2, gridSize*2)
	o.blockGrid = {}
	for x=1,2 do
		local col = {}
		for y=1,2 do
			col[y] = Block((x-1)*gridSize, (y-1)*gridSize, math.random(1, 4))
			col[y].c1:set(colors[y][1], colors[y][2], colors[y][3], 255)
			col[y].c2:set(colors[y+1][1], colors[y+1][2], colors[y+1][3], 255)
		end
		o.blockGrid[x] = col
	end
end)
function BBlock:draw()
	for x=1,2 do
		for y=1,2 do
			self.blockGrid[x][y]:draw()
		end
	end
end
function BBlock:setPosition(x, y)
	Object.setPosition(self, x, y)
	if self.blockGrid then
		for x=1,2 do
			for y=1,2 do
				self.blockGrid[x][y]:setPosition(self.pos.x+(x-1)*gridSize, self.pos.y+(y-1)*gridSize)
			end
		end
	end
end
-- mainState = WrapperState(Group());
-- mainState:changeState(PlayState())
