-- define the blocks in the following way
Block = class(GradientObject, function(o, x, y, t)
	GradientObject.init(o, x, y, gridSize, gridSize, bludColor(50,10,70), bludColor(100,20,30))
	o.type = t or 1
end)
function Block:draw()
	-- print(self)
	local cameras = self.cameras or bludG.cameras
	if not self.cam then
		self.cam = Rectangle(0, 0, bludG.camera.w, bludG.camera.h)
	end
	local flip = 0
	if self.flip then flip = self.flip end

	if self.sprite then
		-- loop through all the cameras
		-- print(bludG.camera.scale)
		for i,camera in pairs(cameras) do
			-- print(camera.scale)
			local px, py, pw, ph = self.pos.x, self.pos.y, self.w, self.h
			self.pos.x, self.pos.y, self.w, self.h = Object.getCameraOffsetZoom(self, camera)
			-- self.pos.x, self.pos.y = self.pos.x*camera.scale, self.pos.y*camera.scale
			-- draw the sprite if it is on the current camera
			local cam = Rectangle(0, 0, camera.w, camera.h)
			if self:doesRectangleTouch(camera) or asLine then
				-- calculate the position on the current camera
				local c = {self.pos.x, self.pos.y, self.w, self.h}
				local tl, tr, bl, br = self:cornerType(c)
				self.sheet:addCornerColorTile(self.sprite, tl[1],tl[2], tr[1],tr[2], bl[1],bl[2], br[1],br[2], self.layer, flip, self.c1, self.c1, self.c2, self.c2)
			end
			self.pos.x, self.pos.y, self.w, self.h = px, py, pw, ph
		end
	end
end
function Block:cornerType(c)
	local tl = {c[1], c[2]}
	local tr = {c[1]+c[3], c[2]}
	local bl = {c[1], c[2]+c[4]}
	local br = {c[1]+c[3], c[2]+c[4]}
	if self.type == 1 then
		return bl, tr, bl, br
	end
	if self.type == 2 then
		return tl, tr, bl, bl
	end
	if self.type == 3 then
		return tl, tl, bl, br
	end
	if self.type == 4 then
		return tl, tr, br, br
	end
end