Bullet = class(CenteredObject, function(o, x, y)
	o.sprite = sprites['ui']['circle.png']
	o.h = o.sprite:getTexHeight()
	o.w = o.sprite:getTexWidth()
	CenteredObject.init(o, x, y, o.w, o.h)
	o.moves = true
	o.maxAge = 200
	o:updateRotation()
	o.particles = mainState.particles:addRecycle(ParticleHandler(0,0, "particle_data_bullet_explode_blue.lua", sprites['ui']['circle.png'], {immortal=true}))
	o:setScale(0.1)
end)
function Bullet:setScale(scale)
	self.scale = scale
	self.h = self.sprite:getTexHeight()*self.scale
	self.w = self.sprite:getTexWidth()*self.scale
end
function Bullet:update()
	Object.update(self)
	self.particles.pl.particles:setPosition(self.pos.x, self.pos.y)
	self.particles.pl.particles:add(math.random(1, 3))
	self.maxAge = self.maxAge-1
	if self.maxAge < 0 then self:kill() end
end
function Bullet:kill()
	Object.kill(self)
	mainState.particles:remove(self.particles)
end
function Bullet:updateRotation()
	self.rot = math.deg(math.pi-self.velocity:angle())
end