HeroObject = class(CenteredObject, function(o, x, y)
	CenteredObject.init(o, x, y, sprites['ui']["head.png"]:getWidth()*0.25,sprites['ui']["head.png"]:getWidth()*0.25)
	o.sheet = sheets['ui']
	o.sprite = sprites['ui']["head.png"]
	o.drawType = 'stretched'
	o:setColor(255, 255, 255)
	o.moves = true
	o.immovable = false
	o.jetacceleration = Vec2(0,0)
	o.rot = 90
	o.scale = 1
	o.trail = TrailObject(sprites['ui']['white.png'], sheets['ui'], 30)
	o.trail:setColor(getYellow())
	o.pushPower = 15;
	o.shotCharge = 0;
	o.shotChargeDisplay1 = ShotCharge(0,0)
	o.shotChargeDisplay2 = ShotCharge(0,0)
	local ss = sprites['additive']['shield.png']
	o.shield = CenteredObject(x, y, ss:getWidth(), ss:getHeight())
	o.shield.sheet = sheets['additive']
	o.shield:setColor(255, 255, 255 ,255)
	o.shield.sprite = ss
	o.shieldTime = 0.25
end)
function HeroObject:useShield()
	self.currentShield = self.shieldTime
end
function HeroObject:hasShield()
	return self.currentShield and self.currentShield > 0
end
function HeroObject:setShotCharge(value)
	self.shotCharge = math.min(2, math.max(0, value))
	self.shotChargeDisplay1:setValue(math.min(1, value))
	if value > 1 then
		self.shotChargeDisplay2:setValue(math.min(1, value-1))
	else
		self.shotChargeDisplay2:setValue(0)
	end
end
function HeroObject:useShieldDischarged()
	self.shotChargeDisplay1:flash()
	self.shotChargeDisplay2:flash()
end
function HeroObject:getShotCharge()
	return self.shotCharge
end
function HeroObject:update()
	self.shotChargeDisplay1:update()
	self.shotChargeDisplay2:update()
	if self.currentShield then
		self.currentShield = self.currentShield-bludG.elapsed
		self.shield:setPosition(self.pos.x, self.pos.y)
		if self.currentShield <= 0 then
			self.currentShield = nil
		end
	end
	CenteredObject.update(self)
	if self.autofly then
		self.moves = false
		self.last.x, self.last.y = self.pos.x, self.pos.y
		self.pos.y = math.sin(bludG.last_t*2)*10*r_scale+bludG.camera.h/2
	else
		self.moves = true
	end
	local r,g,b = HSVtoRGB(bludG.last_t/10, 1, 1)
	self.currentTrailColor = {r,g,b}
	local scc = game_settings['shield_charge_color']
	self.shotChargeDisplay1:setColor(scc[1], scc[2], scc[3])
	self.shotChargeDisplay2:setColor(scc[1], scc[2], scc[3])
	local healthPercent = (mainState.substate.healthBar.value-mainState.substate.healthBar.min)/mainState.substate.healthBar.max
	local ps = .25*healthPercent
	ps = ps*0.5
	self.trail:addPoint(self.pos.x+mainState.substate.bg_scrollx, self.pos.y, 25*r_scale*ps*4)
	self.trail:modWidth(0.98)
	self.pushPower = self.pushPower*0.97;
end
function HeroObject:draw()
	if self.currentShield then
		self.shield:draw()
	end
	-- self.particles.pl.particles:draw(mainState.substate.bg_scrollx, bludG.camera.scroll.y, bludG.camera.scale)
	self.trail:draw(mainState.substate.bg_scrollx, bludG.camera.scroll.y, bludG.camera.scale)

	-- need to keep a running copy of the camera position so that I can calculate the rotation
	if not self.lastCamera then self.lastCamera = 0 end
	if not self.cameraDiff then self.cameraDiff = self.lastCamera-mainState.substate.bg_scrollx end
	self.cameraDiff = self.lastCamera-mainState.substate.bg_scrollx
	if not mainState.substate.paused then
		local newRot = math.deg(self.pos:copy():sub(self.last:copy():sub(Vec2(self.cameraDiff, 0))):normalize():angle()+math.pi/2)
		-- do a little bit of averaging of the rotations
		self.rot = (self.rot+newRot)/2
	end
	local amp = (20+math.sin(bludG.last_t*5)*5)*r_scale
	local phase = math.pi/2
	self.shotChargeDisplay1:setPosition(self.pos.x+math.cos(phase)*amp, self.pos.y+math.sin(phase)*amp)
	self.shotChargeDisplay2:setPosition(self.pos.x+math.cos(phase+math.pi)*amp, self.pos.y+math.sin(phase+math.pi)*amp)
	self.shotChargeDisplay1:draw()
	self.shotChargeDisplay2:draw()

	self.tint.a = 255
	local hit = ""
	if self.flash then
		hit = "_hit_1"
		if (math.floor(bludG.last_t * 20) % 2) == 0 then
			hit = "_hit_2"
		end
	end
	self.sprite = sprites['ui']["head"..hit..".png"]
	CenteredObject.draw(self)
	self.lastCamera = mainState.substate.bg_scrollx
end