SmashTri = class(TriangleObject, function(o, x, y, tx, ty, ...)
	local arg = {...}
	if arg[1] == nil then
		options = {}
	else
		options = arg[1]
	end
	TriangleObject.init(o, x, y)
	o.onComplete = options.onComplete
	o:setSize(20*r_scale)
	o:setColor(getYellow())
	o:setRot(-19)
	o.t = t
	o.particles = ParticleHandler(tx, ty, "particle_data_smoke.lua",
	sprites['ui']['smokeParticle.png'],
	{
		immortal=true,
		numParticles=30,
		sheet=sheets['ui']
	})
	o.particles2 = ParticleHandler(tx, ty, "particle_data_explosion.lua",
	sprites['ui']['triangle.png'],
	{
		immortal=true,
		numParticles=20,
		sheet=sheets['ui']
	})
	Tweener:addTween(o.pos, {x=tx, y=ty}, {func="easeNone", time=0.3, onComplete=function()
		o.particles.pl.particles:add(30)
		o.particles2.pl.particles:add(20)
		bludG.camera:shake(0.3)
		addHalo(o.pos)
		r,g,b = getYellow()
		Tweener:addTween(o.tint, {r=255,g=255,b=255}, {time=0.4, onComplete=function()
			if o.onComplete then o.onComplete() end			
			Tweener:addTween(o.tint, {r=r,g=g,b=b}, {time=1.7, onComplete=function()
			end})			
		end})
	end})
end)
function SmashTri:update()
	self.particles.pl.particles:update(bludG.elapsed)
	self.particles2.pl.particles:update(bludG.elapsed)
	self:calculateCorners()
	TriangleObject.update(self)
end
function SmashTri:draw()
	self.particles:draw()
	self.particles2:draw()
	TriangleObject.draw(self)
end

function addHalo(pos)
	local to = mainState.particles:addRecycle(TObject(pos.x, pos.y, {resolution=20})) 
	if SynthData and SynthData.coin_tint then
		local t = SynthData.key_tint
		to:setColor(t[1], t[2], t[3], 200)
	end
	Tweener:addTween(to.tint, {a=0, r=0, g=0, b=0}, {time=1.4, onComplete=function()
		to:kill()
	end})
	Tweener:addTween(to, {innerSize=98*r_scale, outerSize=100*r_scale}, {func="easeNone", time=.5, onComplete=function()
	end})
end