TiltedButton = class(TiltedRect, function(o, x, y, mainText, subText, offset)
	o.bg = TiltedRect(x, y-5*r_scale, bludG.camera.w, 35*r_scale)
	o.bg.sprite = sprites['ui']['white.png']
	o.bg.drawType = 'stretched'
	o.bg.sheet = sheets['ui']
	o.bg:setColor(0,0,0)
	local offset = offset or 50
	TiltedRect.init(o, x+offset, y, bludG.camera.w, 35*r_scale)
	o.sprite = sprites['ui']['white.png']
	o.drawType = 'stretched'
	o.sheet = sheets['ui']
	o:setColor(209, 207,199)
	if mainText then
		o.mainText = StringObject(o.pos.x+10*r_scale, o.pos.y+5*r_scale, mainText, nil, 0.5)
		o.mainText:setColor(0,0,0)
	end
	if subText then
		o.subText = StringObject(x+10*r_scale, o.pos.y-20*r_scale, subText, nil, 0.4)
		o.subText:setColor(0,0,0)
	end
	o.touchDown = CameraButton.touchDown
	o.touchUp = CameraButton.touchUp
end)
function TiltedButton:draw()
	if self.bg then
		self.bg:draw()
	end
	TiltedRect.draw(self)
	if self.mainText then
		self.mainText:draw()
	end
	if self.subText then
		self.subText:draw()
	end
end
function TiltedButton:update()
	Object.update(self)
	if self.removing and self.alive then
		self:calculateCorners()
		if self.bg then	self.bg:calculateCorners() end
		if self.mainText then self.mainText:update() end
		if self.subText then self.subText:update() end
	end
end
function TiltedButton:presentAnimated()
	-- move off screen, then add the animations to move it to the proper position
	local bgTarget, mainTarget = self.bg.pos.x, self.pos.x
	self.removing = true
	local p = 20*r_scale
	local t = 0.9
	self.tweens = {}
	self.bg.pos.x = -self.bg.w-p
	self.pos.x = bludG.camera.w+p
	local tw = Tweener:addTween(self.bg.pos, {x=bgTarget}, {time=t, onComplete=function()
		self.removing = false
	end})
	table.insert(self.tweens, tw)
	tw = Tweener:addTween(self.pos, {x=mainTarget}, {time=t})
	table.insert(self.tweens, tw)
end
function TiltedButton:removeAnimated()
	if self.tweens then
		for i,v in ipairs(self.tweens) do
			Tweener:removeTween(v)
		end
	end
	self.removing = true
	-- copy self to the mainstate particles, then kill after animation
	mainState.particles:addRecycle(self)
	local p = 20*r_scale
	local t = 0.9
	Tweener:addTween(self.bg.pos, {x=-self.bg.w-p}, {time=t, onComplete=function()
		self:kill()
		self.bg.alive = false
	end})
	Tweener:addTween(self.pos, {x=bludG.camera.w+p}, {time=t})
	if self.mainText then
		Tweener:addTween(self.mainText.tint, {a=0}, {time=t})
	end
	if self.subText then
		Tweener:addTween(self.subText.tint, {a=0}, {time=t})
	end
end