-- assume all tilts at 19deg (same as our font)
TiltedRect = class(Object, function(o, x, y, w, h)
	Object.init(o, x, y, w, h)
	o:calculateCorners()
	o.fingerDown = {}
	o.fingerCount = 0
end)
function TiltedRect:calculateCorners()
	if not self.tl then
		self.tl, self.tr, self.bl, self.br = self.pos:copy(), self.pos:copy(), self.pos:copy(), self.pos:copy()
		self.tlc, self.trc, self.blc, self.brc = Vec2(0,0), Vec2(0,0), Vec2(0,0), Vec2(0,0)
	else
		-- copy into the vectors
		self.tl:set(self.pos)
		self.tr:set(self.pos)
		self.bl:set(self.pos)
		self.br:set(self.pos)
	end
	-- there should be a fixed relation between the height and the amount of offset... going to just hardcode for now, figure out the math later
	local offset = self.h*0.19
	self.tl:set(self.pos)
	self.tr.x, self.tr.y = self.pos.x+self.w, self.pos.y
	self.bl.x, self.bl.y = self.pos.x-offset, self.pos.y+self.h
	self.br.x, self.br.y = self.pos.x+self.w-offset, self.pos.y+self.h
	-- rotate the bottom points
end
function TiltedRect:setPosition(x, y)
	Object.setPosition(self, x, y)
	self:calculateCorners()
end
function TiltedRect:draw()
	-- print(self)
	local cameras = self.cameras or bludG.cameras
	if not self.cam then
		self.cam = Rectangle(0, 0, bludG.camera.w, bludG.camera.h)
	end
	local flip = 0
	if self.flip then flip = self.flip end
	if self.sprite then
		local camera = bludG.camera
			bludG.camera:worldToScreen(self.tl, self.tlc, self.scrollFactor)
			bludG.camera:worldToScreen(self.tr, self.trc, self.scrollFactor)
			bludG.camera:worldToScreen(self.bl, self.blc, self.scrollFactor)
			bludG.camera:worldToScreen(self.br, self.brc, self.scrollFactor)
			-- calculate the position on the current camera
			self.sheet:addCornerTile(self.sprite, self.tlc.x, self.tlc.y, self.trc.x, self.trc.y, self.blc.x, self.blc.y, self.brc.x, self.brc.y, self.layer, flip, self.tint.r, self.tint.g, self.tint.b, self.tint.a)
	end
end