FlyAwayFriend = class(CenteredObject, function(o, x, y, spr)
	CenteredObject.init(o,x,y,10,10)
	o.sprites = spr
	o.moves = true
	o.trail = TrailObject(sprites['ui']['white.png'], sheets['ui'], 100)
	o.trail:setColor(HSVtoRGB(math.random(), 1, 1))
	for i=1,100 do
		o.trail:addPoint(o.pos.x+mainState.substate.bg_scrollx, o.pos.y, 0*r_scale)
	end
end)
function FlyAwayFriend:update()
	CenteredObject.update(self)
	if self.pos.x > 0 and self.pos.x < bludG.camera.w and self.pos.y>0 and self.pos.y<bludG.camera.h then
	else
		self:kill()
	end
	local r,g,b = HSVtoRGB(bludG.last_t/10, 1, 1)
	self.currentTrailColor = {r,g,b}
	self.trail:addPoint(self.pos.x+mainState.substate.bg_scrollx, self.pos.y, 12*r_scale)
	self.trail:modWidth(0.98)
end
function FlyAwayFriend:draw()
	self.trail:draw(mainState.substate.bg_scrollx, bludG.camera.scroll.y, bludG.camera.scale)
	CenteredObject.draw(self)
end
 --directControl = true
Wall = class(CenteredObject, function(o)
	local wallWidth = 60*r_scale
	CenteredObject.init(o, bludG.camera.w+wallWidth, bludG.camera.h/2, wallWidth, 10)
	local waitTween = Tweener:addTween(o, {scale=0.5}, {time=1.5+math.random(), onComplete=function()
		o.slideInTween = Tweener:addTween(o.pos, {x=bludG.camera.w-wallWidth}, {time=1+math.random()})
	end})
	o.scale = 1
	o.rot = 0
	o.rotSpeed = 2
	o.friendCount = math.random(1,12)
	o.moves = true
	o.health = ArcBar(0,0, {innerSize=18*r_scale, outerSize=20*r_scale, sheet=sheets['additive'], sprite=sprites['additive']['white.png']})
end)
function Wall:update()
	self.scale = 0.75
	CenteredObject.update(self)
	self.rot = self.rot + self.rotSpeed
	if self.pos.y+self.h/2>bludG.camera.h and self.velocity.y > 0 then
		self.velocity.y = -self.velocity.y
		self.rotSpeed = self.rotSpeed-math.random()*5
		self.velocity.x = self.velocity.x*3*(math.random()+0.5)
	end
	if not self.dead then
		self.pos.y = math.sin(bludG.last_t)*bludG.camera.h/4+bludG.camera.h/2
		self.health:setPosition(self.pos.x, self.pos.y)
		self.health:update()
	end
end
function Wall:setPaused()
	self.health:setColor(0,0,0,0)
end
function Wall:setUnPause()
	self.health:setColor(255, 255, 255, 100)
end
function Wall:draw()
	local numfriends = 6
	local op = self.pos:copy()
	local orot = self.rot
	self.sprite = sprites['ui']['friend_'.. self.friendCount ..'.png']
	CenteredObject.draw(self)
	local t = SynthData.key_tint
	self:setColor(t[1], t[2], t[3], 200)
	self.sprite = sprites['ui']['bubble_back.png']
	CenteredObject.draw(self)
	self:setColor(255, 255, 255)
	self.sprite = sprites['ui']['bubble_front.png']
	CenteredObject.draw(self)
end
function Wall:explode()
	pd:startList("fromOF")
	pd:addSymbol("loopComplete")
	pd:addFloat(player.currentBpm*4)
	pd:finish()
	Tweener:removeTween(self.slideInTween)
	addTorus(self.pos)
	addPop(self.pos)
	addFriend(self.pos, sprites['ui']['friend_'.. self.friendCount ..'.png'], self.rot)
	self:kill()
end
function addFriend(pos, spr, rot)
	local f = mainState.particles:addRecycle(FlyAwayFriend(pos.x, pos.y, spr))
	f.sprite = spr
	f.rot = rot
	f.acceleration = Vec2(1, 0):rotate(math.rad(f.rot)-math.pi/2):mult(300)
end
function addPop(pos)
	local pop = mainState.particles:addRecycle(CenteredObject(pos.x, pos.y, 10, 10))
	pop.sprite = sprites['ui']['bubble_pop.png']
	pop.scale = 0.75
	Tweener:addTween(pop, {scale=1.25}, {time=0.3, func='easeNone', onComplete=function()
		pop:kill()
	end})
end
