-- a full screen black overlay
ZipGroup = class(Object, function(o, completionCallback)
	Object.init(o, 0,0,bludG.camera.w, bludG.camera.h)
	o.sprite = sprites['ui']['white.png']
	o:setColor(0,0,0)
	o.numsegments = 12
	o.segmentPosition = {}
	o.segmentTween = {}
	o.targets = {}
	-- o:setColor(0,0,0)
	for i=0,o.numsegments do
		o.segmentPosition[i] = 0
		o.segmentTween[i] = Tweener:addTween(o.segmentPosition, {[i]=0}, {time=i*0.05, func='easeInOutSine', onComplete=function()
			o.segmentTween[i] = Tweener:addTween(o.segmentPosition, {[i]=bludG.camera.h/2}, {time=0.5, func='easeInOutSine', onComplete=function()
				if i == o.numsegments then
					print('calling back')
					if completionCallback then completionCallback() end
				end
			end})
		end})
	end
	o.tlc, o.trc, o.blc, o.brc = Vec2(0,0), Vec2(0,0), Vec2(0,0), Vec2(0,0)
end)
function ZipGroup:unzip(completionCallback)
	local blanks = {}
	for i=0,self.numsegments do
		-- self.segmentPosition[i] = 0
		Tweener:addTween(blanks, {}, {time=i*0.05, func='easeInOutSine', onComplete=function()
			if self.segmentTween[i] then Tweener:removeTween(self.segmentTween[i]) end
			Tweener:addTween(self.segmentPosition, {[i]=0}, {time=0.5, func='easeInOutSine', onComplete=function()
				if i == self.numsegments then
					if completionCallback then completionCallback() end
				end
			end})
		end})
	end
end
function ZipGroup:draw()
	for i=0,self.numsegments-1 do
		self.tlc:set(bludG.camera.w/self.numsegments*i, 0)
		self.trc:set(bludG.camera.w/self.numsegments*(i+1), 0)
		self.blc:set(bludG.camera.w/self.numsegments*(i), self.segmentPosition[i])
		self.brc:set(bludG.camera.w/self.numsegments*(i+1), self.segmentPosition[i+1])
		self.sheet:addCornerTile(self.sprite, self.tlc.x, self.tlc.y, self.trc.x, self.trc.y, self.blc.x, self.blc.y, self.brc.x, self.brc.y, self.layer, flip, self.tint.r, self.tint.g, self.tint.b, self.tint.a)
		
		self.tlc:set(bludG.camera.w/self.numsegments*i, bludG.camera.h)
		self.trc:set(bludG.camera.w/self.numsegments*(i+1), bludG.camera.h)
		self.blc:set(bludG.camera.w/self.numsegments*(i), bludG.camera.h-self.segmentPosition[i])
		self.brc:set(bludG.camera.w/self.numsegments*(i+1), bludG.camera.h-self.segmentPosition[i+1])
		self.sheet:addCornerTile(self.sprite, self.tlc.x, self.tlc.y, self.trc.x, self.trc.y, self.blc.x, self.blc.y, self.brc.x, self.brc.y, self.layer, flip, self.tint.r, self.tint.g, self.tint.b, self.tint.a)
	end
end