BackgroundSynthStack = class(Group, function(o)
	Group.init(o)
	o.items = o:add(Group())
end)

function BackgroundSynthStack:addItem(synth, beatCount, y, currentLoop)
	local s = synth
	currentLoop = currentLoop or 1
	print(currentLoop)
	-- push the item to the end of the table
	beatCount = (beatCount-1)%16
	local hero = mainState.substate.hero
	local x = ((bludG.camera.w-hero.pos.x)*(beatCount/16))+hero.pos.x
	local i = self.items:add(Vec2(x, y))
	i.beatCount = beatCount
	i.currentLoop = currentLoop
	i.alive = true
	i.exists = true
	-- remove the element from the front of the table if we have too many elements
end
function BackgroundSynthStack:emptyOld(currentLoop)
	self.items:removeIf(function(v)
		if v.currentLoop < currentLoop-3 then
			return true
		end
		return false
	end)
end
function BackgroundSynthStack:setStep(step)
	step = (step-1)%16
	self.currentStep = step
	-- pop up the synthobjects that are on this step
	self.items:call(function(v)
		if v.beatCount == step then
			addPing(v)
		end
	end)
end

function addPing(pos)
	local to = mainState.particles:addRecycle(CenteredObject(pos.x, pos.y, 10, 10)) 
	to.scale = 0.1
	to.sprite = sprites['additive']['circle.png']
	to.sheet = sheets['additive']
	if SynthData.coin_tint then
		local t = BackgroundData.under_color
		to:setColor(t[1], t[2], t[3], 255)
	end
	-- Tweener:addTween(to, {outerSize=30}, {func="easeNone", time=0.5})
	Tweener:addTween(to.tint, {a=0, r=0, g=0, b=0}, {time=1.8, onComplete=function()
	  to:kill()
	end})
end