-- ------------------------------- --
-- ------------------------------- --
-- ------------------------------- --
TiltedCamButton = class(TiltedRect, function(o,x,y,w,h, text)
	TiltedRect.init(o, x, y, w, h)
	o.sprite = sprites['ui']['white.png']
	o.drawType = 'stretched'
	o.sheet = sheets['ui']
	o:setColor(147,146,140)
	o.touchDown = CameraButton.touchDown
	o.touchUp = CameraButton.touchUp
	o.noParticle = true
	o.scrollFactor = Vec2(0,0)
	if text then
		o.text = StringObject(0,0, text, nil, 0.5)
		o.text:setColor(255, 255, 255)
		o.text:setPosition(o.pos.x+o.w/2-o.text.w*0.75, o.pos.y+o.h/2-o.text.h/2)
		o.text:setScrollFactor(Vec2(0,0))
	end
end)
function TiltedCamButton:draw()
	TiltedRect.draw(self)
	if self.text then
		self.text:draw()
	end
end
-- ------------------------------- --
-- ------------------------------- --
-- ------------------------------- --
DrumMachineOverlay = class(SvgMenuGroup, function(o, parent)
	Group.init(o)
	o.parent = parent
	o.topBar = o:add(Object(0,0,bludG.camera.w, bludG.camera.h/9))
	o.topBar.sprite = sprites['bg']['white.png']
	o.topBar.sheet = sheets['bg']
	o.topBar.drawType = 'stretched'
	o.topBar:setColor(0,0,0)
	o:setupBottom()
end)
function DrumMachineOverlay:setupBottom()
	local o = self
	local p = 3
	local uiData = {
		['t']=bludG.camera.h-35*r_scale;
	}
	local line = {
		['t'] = 'UIline';
		['c'] = {209, 207, 199};
		['subs']={
			{
				['t']='UIbutton';
				['align']='left';
				['text']='menu';
				['onPress']=function()
					o:back_callback()
				end
			},
			{
				['t']='UIspacer';
				['align']='left';
				['c']={0,0,0};
			},
			{
				['t']='UIbutton';
				['align']='right';
				['text']='next';
				['onPress']=function()
					o:next_callback()
				end
			},
			{
				['t']='UIspacer';
				['align']='right';
				['c']={0,0,0};
			},
			{
				['t']='UIbutton';
				['align']='right';
				['text']='prev';
				['onPress']=function()
					o:prev_callback()
				end
			},
			{
				['t']='UIspacer';
				['align']='right';
				['c']={0,0,0};
			},
			{
				['t']='UIbutton';
				['align']='right';
				['text']='play';
				['onPress']=function()
					o:play_callback()
				end
			},
			{
				['t']='UIspacer';
				['align']='right';
				['c']={0,0,0};
			},
		};
	}
	if bludParseQuery and gk and gk:isConnected() then
		table.insert(line.subs,{
				['t']='UIbutton';
				['align']='left';
				['text']='share';
				['onPress']=function()
					o:share_callback()
				end
		})
	end
	table.insert(uiData, line)
	local canvas = o:add(UICanvas(uiData))
end
function DrumMachineOverlay:play_callback()
	self.parent.playbuttonPress()
end
function DrumMachineOverlay:share_callback()
	self.savingOverlay = self:add(LoadingState("saving"))
	UploadSongToServer(self.parent.songData, function()
		self:remove(self.savingOverlay)
	end)						
end
function DrumMachineOverlay:next_callback()
	self.parent.nextPatternPress()
end
function DrumMachineOverlay:prev_callback()
	self.parent.prevPatternPress()
end
function DrumMachineOverlay:back_callback()
	-- if the user hasn't logged in with game center, then don't let them save to server
	self.parent:add(DrumMachineOverlayMenu(self))
	pd:startList("fromOF")
	pd:addSymbol("stopTimer")
	pd:addFloat(player.currentBpm*4)
	pd:finish()
	self.parent.stepDisplay:call(function(v)
		if v.alphaTween then Tweener:removeTween(v.alphaTween) end
		v.alphaTween = Tweener:addTween(v.tint, {a=0})
	end)
end