BpmEditor = class(DragArea, function(o, x, y, w, h, value, callback)
	bg:setBackground(120, 120, 120)
	DragArea.init(o, x, y, w, h)

	o.sprite = sprites['ui']['white.png']
	o.drawType = 'stretched'
	o:setColor(0,0,0)

	o.fvalue = value or 120
	o.value = o.fvalue
	o.bpmText = StringObject(0,0,o.value,nil,0.75)
	o.bpmText:setColor(getYellow())
	o.bpmText:setPosition(o.pos.x+o.w/2-o.bpmText.w/2,o.pos.y+o.h/2-o.bpmText.h/2)
	o.bpmText:setLayer(1)
	o.onMove = function(da, x, y, id)
		local diff = 1/r_scale*(x-da.lastPos[id].x)*0.1
		o.fvalue = o.fvalue+diff
		o.value = math.floor(o.fvalue)
		if callback then callback(o.value) end
		o.bpmText:setValue(o.value)
	end
end)
function BpmEditor:draw()
	Object.draw(self)
	self.bpmText:draw()
end
DrumMachineOverlayMenu = class(Group, function(o, parent)
	Group.init(o)
	o.parent = parent
	o:setup()
end)
function DrumMachineOverlayMenu:setup()
	local o = self
	o.blank = o:add(Object(0,0,bludG.camera.w, bludG.camera.h))
	o.blank.drawType = 'stretched'
	o.blank.sprite = sprites['ui']['white.png']
	o.blank:setColor(0,0,0,200)
	local uiData = {['paddingTop']=50*r_scale}
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['subs']={
			{
				['t']='UIlabel';
				['align']='left';
				['text']='bpm';
			},
			{
				['t']='UIBpmEditor';
				['align']='left';
				['value']=o.parent.parent.songData.bpm;
				['callback']=function(value, canvas)
					o.parent.parent.songData.bpm = value
				end;
			},
			{
				['t']='UIbutton';
				['text']='paste';
				['align']='right';
				['onPress']=function()
					o.parent.parent:paste()
				end;
			},
			{
				['t']='UIspacer';
				['align']='right';
			},
			{
				['t']='UIbutton';
				['text']='copy';
				['align']='right';
				['onPress']=function()
					o.parent.parent:copyCurrent()
				end;
			},
			{
				['t']='UIspacer';
				['align']='right';
			},
			{
				['t']='UIbutton';
				['text']='cut';
				['align']='right';
				['onPress']=function()
					o.parent.parent:cutCurrent()
				end;
			},
		};
	}
	table.insert(uiData, line)
	if bludParseQuery and gk and gk:isConnected() then
		local line = {
			['t'] = 'UIline';
			['c'] = bgc(1);
			['paddingBottom']=15*r_scale;
			['subs']={
				{
					['t']='UIbutton';
					['text']='upload';
					['align']='right';
					['onPress']=function()
						self.savingOverlay = self:add(LoadingState("saving"))
						UploadSongToServer(self.parent.parent.songData, function()
							self:remove(self.savingOverlay)
						end)						
					end;
				},
			};
		};
		table.insert(uiData, line)
	end
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['valign']='bottom';
		['subs']={
			{
				['t']='UIbutton';
				['text']='back';
				['align']='left';
				['onPress']=function()
					player:setBpm(o.parent.parent.songData.bpm)
					player:startTimer()
					self.parent.parent:remove(o)
					o.parent.parent.stepDisplay:call(function(v)
						if v.alphaTween then Tweener:removeTween(v.alphaTween) end
						v.tint.a = 255
					end)
				end;
			},
			{
				['t']='UIbutton';
				['text']='next';
				['align']='right';
				['onPress']=function()
					o.parent:next_callback();
				end;
			},
			{
				['t']='UIbutton';
				['text']='prev';
				['align']='right';
				['onPress']=function()
					o.parent:prev_callback();
				end;
			},
		};
	};
	table.insert(uiData, line)
	local canvas = o:add(UICanvas(uiData))
	WorldSelectMenu.addTopBar(o, '', function()
		mainState = WrapperState(Group());
		mainState:changeState(EditSelectMenu())
	end, 'exit')
end
-- don't allow fallthrough
function DrumMachineOverlayMenu:touchDown(x, y, id)
	Group.touchDown(self, x, y, id)
	return false
end

function DrumMachineOverlayMenu:touchMoved(x, y, id)
	Group.touchMoved(self, x, y, id)
	return false
end
function DrumMachineOverlayMenu:touchUp(x, y, id)
	Group.touchUp(self, x, y, id)
	return false
end
