function RemoveButtons(g)
	g:call(function(v)
		v:removeAnimated()
	end)
end
EditSelectMenu = class(Group, function(o)
	bg:setBackground(getColor())
	Group.init(o)
	o.rotOff = -19
	o.tsize = 50*r_scale
	o.padding = 120*r_scale
	o.tris = o:add(Group())
	-- add a title bar
	-- add the buttons for the 
	-- add a button for creating a new song
	o:setup()
end)
function EditSelectMenu:setup()
	local o = self
	local bPos = 1
	local fc = Vec2(120*r_scale,70*r_scale)
	o.songButtons = o:add(Group())
	o.settingButtons = o:add(Group())
	local uiData = {['paddingTop']=50*r_scale}
	local levels = fs:enumerate("/player_levels")
	for i=1,player.serverSlots do
		local line = {
			['t'] = 'UIline';
			['c'] = bgc(1);
			['paddingBottom']=15*r_scale;
			['subs']={}
		}
		local level = persistence.load(blud.doc_root .. "/player_levels/level_"..i..".lua");
		table.insert(line.subs, {
				['t']='UIbutton';
				['text']='options';
				['align']='left';
				['onPress']=function()
					-- make a new level for this slot
					o:fixCamera()
					mainState = WrapperState(Group());
					mainState:changeState(SettingState(level, i));
					return false
				end;
			}
		)
		table.insert(line.subs, {
				['t']='UIspacer';
				['c']={0,0,0};
				['align']='left';
			}
		)
		if level then
			print(level, level.worldPack, i)
			table.insert(line.subs, {
					['t']='UIbutton';
					['text']='edit';
					['align']='right';
					['onPress']=function()
						o:fixCamera()
						-- load the world for this level
						player:loadWorldPack(level.worldPack, nil, function()
							-- load the level for editing
							mainState:replaceState(mainState.substate, SH3EditState(level, i))
							RemoveButtons(o.songButtons)
						end)
					end;
				}
			)
			table.insert(line.subs, {
					['t']='UIsmallworld';
					['world']=level.worldPack;
					['align']='left';
				}
			)
			table.insert(line.subs, {
					['t']='UIspacer';
					['align']='left';
				}
			)
			table.insert(line.subs, {
					['t']='UIlabel';
					['align']='left';
					['text']=level.name;
				}
			)
		else
			table.insert(line.subs, {
					['t']='UIbutton';
					['text']='new';
					['align']='right';
					['onPress']=function()
						-- make a new level for this slot
						o:fixCamera()
						mainState = WrapperState(Group());
						mainState:changeState(NameSongMenu(i))
						RemoveButtons(o.songButtons)
					end;
				}
			)
		end
		table.insert(line.subs, {
				['t']='UIspacer';
				['c']={0,0,0};
				['align']='right';
			}
		)
		table.insert(uiData, line)
	end
	local canvas = o:add(UICanvas(uiData))
	WorldSelectMenu.addTopBar(o, 'make song', function()
		o:fixCamera()
		mainState = WrapperState(Group());
		mainState:changeState(ModeMenu())
		-- remove all of our buttons
		RemoveButtons(o.songButtons)
	end)
	SongSelectMenu.setupDragArea(o, canvas.h)
end
function EditSelectMenu:fixCamera()
	bludG.camera.scroll.y = 0
end
function EditSelectMenu:panModeHandler(da, x, y, id)
	local p = Vec2(x, y)
	p:sub(da.lastPos[id])
	p.x = 0
	self.moveAmt:add(p)
	bludG.camera.scroll:sub(p)
end
-- mainState = WrapperState(Group());
-- mainState:changeState(EditSelectMenu())
