-- get your friends created level and likes
FriendData = function(completionCallback)
	local likeReturn = {}
	local friendReturn = {}
	local queryCount = 0
	local isCanceled = false
	local cancelFunction = {['cancel']=function() isCanceled = true; end}
	gk:getFriends(function(friends)
		if isCanceled then return; end
		local friends = assert(loadstring(friends))()
		-- contstruct a query to get their level from the server
		local lQuery = 	bludParseQuery("PlayerLevel")
		local showedFailState = false
		lQuery:addDescendingOrder("createdAt")
		local playerIds = {}
		for i,v in ipairs(friends) do
			table.insert(playerIds, v.playerID)
		end
		lQuery:whereKeyContainedIn("userId", playerIds)
		lQuery:findObjects(function(objects, errorCode)
			if not objects then
				if not showedFailState then 
					showedFailState = true
					local errorText = "error"
					if type(errorCode) == 'string' then
						errorText = errorText .. ": " .. errorCode
					else
						errorText = errorText .. " code: " .. errorCode
					end
					mainState:addState(ErrorState(function()
					end, errorText))
					fQuery:cancel()
					completionCallback(likeReturn, friendReturn)
				end
			else
				for i,v in ipairs(objects) do
					local ld = persistence.loadFromString(v:getObject("levelData"))
					table.insert(friendReturn, {ld, v})
				end
				queryCount = queryCount+1
				if queryCount == 2 then
					completionCallback(likeReturn, friendReturn)
				end
			end
		end)
		local fQuery = bludParseQuery("gkUser")
		fQuery:whereKeyContainedIn("userId", playerIds)
		local friendLikeQuery = bludParseQuery("PlayerLevel")
		friendLikeQuery:whereKeyMatchesQuery("likes", fQuery)
		friendLikeQuery:findObjects(function(objects, errorCode)
			if not objects then
				if not showedFailState then 
					showedFailState = true
					local errorText = "error"
					if type(errorCode) == 'string' then
						errorText = errorText .. ": " .. errorCode
					else
						errorText = errorText .. " code: " .. errorCode
					end
					mainState:addState(ErrorState(function()					
					end, errorText))
					lQuery:cancel()
					completionCallback(friendReturn)
				end
			else
				for i,v in ipairs(objects) do
					local ld = persistence.loadFromString(v:getObject("levelData"))
					table.insert(likeReturn, {ld, v})
				end
				queryCount = queryCount+1
				if queryCount == 2 then
					completionCallback(likeReturn, friendReturn)
				end
			end
		end)
		cancelFunction.cancel = function()
			friendLikeQuery:cancel();
			lQuery:cancel();
		end	
	end)
	return cancelFunction
end
FriendsCreatedAndFavoriteSelect = class(SongSelectMenu, function(o)
	SongSelectMenu.init(o)
end)
function FriendsCreatedAndFavoriteSelect:setup()
	bg:setBackground(getColor())
	-- load all songs from server
	pquery = bludParseQuery("PlayerLevel")
	pquery:addDescendingOrder("createdAt")
	-- should throw up a loading from server screen here
	self.songButtons = self:add(Group())
	local cancelFunction = FriendData(function(likeObjects, friendObjects)
		self:remove(self.loadingOverlay)
		local uiData = {['paddingTop']=50*r_scale}
		local line = {
			['t'] = 'UIline';
			['paddingBottom']=15*r_scale;
			['subs']={}
		}
		table.insert(line.subs, {
			['t']='UIlabel';
			['align']='left';
			['text']="friends likes";
		})
		table.insert(uiData, line)
		self:addLines(uiData, likeObjects, "no friend likes found")
		local line = {
			['t'] = 'UIline';
			['paddingBottom']=15*r_scale;
			['subs']={}
		}
		table.insert(line.subs, {
			['t']='UIlabel';
			['align']='left';
			['text']="friends levels";
		})
		table.insert(uiData, line)
		self:addLines(uiData, friendObjects, "no friend levels found")
		local canvas = self.songButtons:add(UICanvas(uiData))
		self:setupDragArea(canvas.h)
	end)
	self.loadingOverlay = self:add(LoadingState(nil, function()
		cancelFunction.cancel();
		self:remove(self.loadingOverlay)
	end))
	WorldSelectMenu.addTopBar(self, 'choose song', function()
		mainState = WrapperState(Group());
		mainState:changeState(GlobeModeMenu())
	end)
end
function FriendsCreatedAndFavoriteSelect:addLines(uiData, objects, fail)
	for i,v in ipairs(objects) do
		local ld = v[1]
		local obj = v[2]
		local line = {
			['t'] = 'UIline';
			['paddingBottom']=15*r_scale;
			['subs']={}
		}
		table.insert(line.subs, {
			['t']='UIlabel';
			['align']='left';
			['text']=obj:getObject("userAlias");
		})
		table.insert(line.subs, {
				['t']='UIspacer';
				['c']={getColor()};
				['align']='left';
			}
		)
		table.insert(line.subs, {
			['t']='UIlabel';
			['align']='left';
			['text']=ld.name;
		})
		table.insert(line.subs, {
			['t']='UIbutton';
			['text']='play';
			['align']='right';
			['onPress']=function()
				if not player.songs[ld] then
					player.songs[ld] = {{}}
				end
				player:loadWorldPack(ld.worldPack, nil, function()				
					player.currentSong = ld
					mainState = WrapperState(Group());
					mainState:changeState(SpaceHero3(ld, v, self))
				end)
			end
		})
		table.insert(uiData, line)
	end
	if #objects == 0 then
		local line = {
			['t'] = 'UIline';
			['paddingBottom']=15*r_scale;
			['subs']={}
		}
		table.insert(line.subs, {
			['t']='UIlabel';
			['align']='left';
			['text']=fail;
		})
		table.insert(uiData, line)
	end
end