HighScoreDisplay = class(Group, function(o, parent)
	Group.init(o)
	local ypos = 0
	o.textAreas = o:add(Group())
end)
function HighScoreDisplay:initialSetup()
	local o = self
	  if not mainState.substate or not mainState.substate.parent:is_a(SH3EditState) then
		local lhs = player:getHighscore(mainState.substate.parseObject, mainState.substate.songData)
		o.lhs = lhs
		if lhs then
			o:addNewText("Personal Best: "..lhs)
		end
		if gk and gk:isConnected() and bludParseQuery then
			-- need to confirm that this is not coming from the server, and isn't coming from edit mode
			if not mainState.substate.parseObject then
				WinScreenData.getHighscoreInternal(o, mainState.substate.songData, function(user, ghighscore)
					o.ghs = ghighscore
					o:addNewText("Global Best: " .. user .. " " ..ghighscore)
				end)
			end
		end
	end
end
function HighScoreDisplay:addNewText(text)
	-- slide up all of the text areas that are on screen
	-- should drop in a textbox below all the existing ones
	-- then remove it
	self.textAreas:call(function(v)
		if v.alive then
			if v.targetYTween then Tweener:removeTween(v.targetYTween) end
			v.targetYTween = Tweener:addTween(v, {targetYPos=v.endY-v.h})
			v.endY = v.endY-v.h
		end
	end)
	local s = self.textAreas:addRecycle(StringObject(0, 0, text))
	if SynthData.backgroundText then
		s:setColor(SynthData.backgroundText[1], SynthData.backgroundText[2], SynthData.backgroundText[3])
	else
		local r,g,b = HSVtoRGB(bludG.last_t, 0.1, 0.5)
		s:setColor(r,g,b)
	end
	local l_align = 20*r_scale
	s:setPosition(-s.w-20*r_scale, bludG.camera.h/4*3-s.h-20*r_scale)
	s.endY = s.pos.y
	s.targetXPos = s.pos.x
	s.targetYPos = s.pos.y
	s.targetXTween = Tweener:addTween(s, {targetXPos=l_align}, {onComplete=function()
		s.targetXTween = Tweener:addTween(s, {targetXPos=l_align}, {onComplete=function()
			s.targetXTween = Tweener:addTween(s, {targetXPos=-s.w-20*r_scale}, {onComplete=function()
				s:kill()
			end})
		end})				
	end})
end
function HighScoreDisplay:update()
	Group.update(self)
	if not self.setup then
		self:initialSetup()
		self.setup = true
	end
	self.textAreas:call(function(v)
		v:setPosition(v.targetXPos, v.targetYPos)
	end)
	if self.lhs and mainState.substate.score > self.lhs and not self.lhsNotify then
		playEffectNew('playPersonalHighScore')
		self:addNewText("New Personal Best!")
		self.lhsNotify = true
	end
	if self.ghs and mainState.substate.score > tonumber(self.ghs) and not self.ghsNotify then
		playEffectNew('playGloballHighScore')
		self:addNewText("New Global Best!")
		self.ghsNotify = true
	end
end
