LocalSongSelectMenu = class(SongSelectMenu, function(o)
	SongSelectMenu.init(o)
end)
function LocalSongSelectMenu:setup()
	bg:setBackground(getColor())
	local o = self
	o.rotOff = -19
	o.tsize = 50*r_scale
	o.padding = 120*r_scale
	o.tris = o:add(Group())
	local uiData = {['paddingTop']=50*r_scale}
	-- load in the songs from each world
	o.songButtons = o:add(Group())
	local fc = Vec2(120*r_scale,100*r_scale)
	for iw,world in ipairs(WorldData) do
		-- load the songs from the level data
		local pcw = world[1]
		if fs:exists("/" .. pcw .. "/levelData.lua") then
			fs:dofile("/" .. pcw .. "/levelData.lua")
		end
		-- add in an icon for the world
		local line = {
			['t'] = 'UIline';
			['paddingBottom']=0;
			['c']={getColor()};
			['paddingTop']=33*r_scale;
			['subs']={}
		}
		table.insert(line.subs, {
			['t']='UIbigworld';
			['world']=world;
			['align']='left';
		})
		table.insert(uiData, line)
		for i,v in ipairs(levelData) do
			if fs:exists("/" .. pcw .. "/levels/" .. v .. ".lua") then
				local ld = persistence.loadFromString(fs:getString("/" .. pcw .. "/levels/" .. v .. ".lua"))
				local line = {
					['t'] = 'UIline';
					['paddingBottom']=15*r_scale;
					['subs']={}
				}		
				table.insert(line.subs, {
					['t']='UIlabel';
					['align']='left';
					['text']=ld.name;
				})
				table.insert(line.subs, {
					['t']='UIbutton';
					['text']='play';
					['id']='songLabel_' .. iw .. "_" .. i;
					['align']='right';
					['onPress']=function()
						player:loadWorldPack(world[3], nil, function()
							-- check to see if the song exists on the player model, if not create it
							if not player.songs[v] then
								player.songs[v] = {{}}
							end
							player.currentSong = ld
							mainState:replaceState(mainState.substate, SpaceHero3(ld, nil, self))
						end)
					end;
				})
				table.insert(line.subs, {
					['t']='UIspacer';
					['c']={243, 242, 236};
					['align']='right';
				})
				table.insert(line.subs, {
					['t']='UIImgButton';
					['img']=sprites['ui']['globe_button.png'];
					['align']='right';
					['onPress']=function()
						mainState:addState(HighscoreState(nil, ld))
					end;
				})
				table.insert(line.subs, {
					['t']='UIsmallStars';
					['align']='right';
					['levelData']=ld;
				})
				table.insert(uiData, line)
			end
		end
	end
	local canvas = o:add(UICanvas(uiData))
	if player.firstRun then
		print('first run')
		local fc = canvas:getObject('songLabel_1_1').pos
		print(fc)
		self:add(HelperHero(fc.x, fc.y))
	end
	self:setupDragArea(canvas.h)
	WorldSelectMenu.addTopBar(self, 'choose song', function()
		mainState = WrapperState(Group());
		mainState:changeState(ModeMenu())
		RemoveButtons(o.songButtons)
	end)
end
function LocalSongSelectMenu:addUnlockTri(fc, ld)
	-- get the unlock info for the current level
	local index = ld.worldPack..ld.name
	local lockInfo = {[1]='locked', [2]='locked', [3]='locked'}
	if ld.stars and player.unlocks[index] then
		for i,v in ipairs(ld.stars) do
			lockInfo[i] = player.unlocks[index][i]
		end
	end
	local triSize = 18*r_scale
	local fc = fc:copy()
	local padding = 90*r_scale
	fc.x = bludG.camera.w-padding-triSize*3
	fc.y = fc.y+25*r_scale
	for i,v in ipairs(lockInfo) do
		-- add the background tri
		local t = self:add(TriangleObject(fc.x, fc.y))
		t:setSize(triSize)
		t:setRot(self.rotOff)
		t:setColor(0,0,0)
		t.forceDraw = true
		-- if we need to, add an overlay
		if lockInfo[i]=='unlocked' then
			local t = self:add(TriangleObject(fc.x-10*r_scale, fc.y-2*r_scale))
			t:setSize(triSize*0.9)
			t:setRot(self.rotOff)
			t:setColor(getYellow())
			t.forceDraw = true
		end
		fc.x = fc.x+triSize*1.5
	end
end
function LocalSongSelectMenu:addTri(fc, world, onPress)
	local o = self
	local t = o.tris:add(TriangleObject(fc.x, fc.y))
	t:setSize(o.tsize)
	t:setRot(self.rotOff)
	t:setColor(world[2][1], world[2][2], world[2][3])
	t.forceDraw = true

	t.st = o:add(StringObject(fc.x-100*r_scale, fc.y-20*r_scale, world[1], nil, 0.75))
	t.st:setColor(0,0,0)
	t.onPress = onPress
	fc.y = fc.y+20*r_scale
end