function getColor()
	return 243, 242, 236
end
ModeMenu = class(Group, function(o, buttonData, backFunction, globeMode)
	bg:setBackground(getColor())
	Group.init(o)
	o:add(BackgroundWaves())
	bludG.camera:zoomTo(0,0,1)
	o.rotOff = -90
	o.tsize = 0
	o.padding = 0
	o.talpha = 0
	o.shadowOff = 3
	Tweener:addTween(o, {rotOff=-19+120, tsize=70*r_scale, padding=78*r_scale, talpha=255}, {func='outSine', time=0.34})
	local center = Vec2(bludG.camera.w/2, bludG.camera.h/2-10*r_scale)
	local rot = Vec2(0,1):normalize():rotate(math.rad(o.rotOff))
	local fc = center:copy():add(rot:copy():mult(o.padding))
	o.subTris = o:add(Group())
	o.tris = o:add(Group())
	o.globeMode = globeMode
	o.buttonData = buttonData or {
		{
			"play",
			function()
				mainState = WrapperState(Group());
				mainState:changeState(LocalSongSelectMenu())
			end
		},
		{
			"make",
			function()
				mainState = WrapperState(Group());
				mainState:changeState(EditSelectMenu())
			end
		},
		{
			"explore",
			function()
				mainState = WrapperState(Group());
				mainState:changeState(GlobeModeMenu())
			end,
			function()
				return bludParseQuery
			end
		},
		{
			"info",
			function()
				mainState = WrapperState(Group());
				mainState:changeState(luckyframeInfo())
			end,
			function()
				return true -- bludParseQuery
			end
		},
	}
	if not buttonData then
		o:setupTitle()
	end
	o:addButtons(fc)
	if player.firstRun and not o.globeMode then
		o:addHelper()
	end
	o.backFunction = backFunction or function()
		mainState = WrapperState(Group());
		mainState:changeState(TopLevelMenu())
	end
	if o.globeMode then
		WorldSelectMenu.addTopBar(o, 'explore', o.backFunction)
	else
		-- WorldSelectMenu.addTopBar(o, 'choose mode', o.backFunction)
	end
end)
function ModeMenu:setupTitle()
	local titleSpr = sprites['ui']['title.png']
	local titleScale = 1
	if r_scale == 4 then
		titleScale = 2
	end
	local title = self:add(Object(20*r_scale,10*r_scale,titleSpr:getWidth()*titleScale, titleSpr:getHeight()*titleScale))
	title.sprite = titleSpr
	title.drawType = 'stretched'

end
function ModeMenu:addHelper()
	self:add(HelperHero(bludG.camera.w/2-120*r_scale, bludG.camera.h/2))
end
function ModeMenu:addButtons(fc)
	for i,v in ipairs(self.buttonData) do
		if v[3] == nil or v[3]() then
			self:addTri(fc, v[1], v[2])
		end
	end
end
function ModeMenu:addTri(fc, text, press, centerOff)
	local o = self
	local t = o.tris:add(TriangleObject(fc.x, fc.y))	
	t:setSize(o.tsize)
	t:setColor(209, 207,199)
	o.centerOff = centerOff or Vec2(0,0)
	t.st = o:add(StringObject(fc.x+o.centerOff.x, fc.y+o.centerOff.y, text, nil, 0.6))
	t.st.centerOff = o.centerOff
	t.st:setColor(0,0,0,0)
	t.onTouch = function()
		if t.colorTween then Tweener:removeTween(t.colorTween) end
		t.colorTween = Tweener:addTween(t.tint, {r=242, g=209, b=15})
	end
	t.onPress = press
	t.sub = o.subTris:add(TriangleObject(fc.x, fc.y))	
	t.sub:setColor(0,0,0,100)
end
function ModeMenu:touchUp(x, y, id)
	Group.touchUp(self, x, y, id)
	for i,v in ipairs(self.tris.members) do
		if v.colorTween then Tweener:removeTween(v.colorTween) end
		v.colorTween = Tweener:addTween(v.tint, {r=209, g=207, b=199})
	end
end
function ModeMenu:update()
	Group.update(self)
	local o = self
	local center = Vec2(bludG.camera.w/2, bludG.camera.h/2-5)
	local rot = Vec2(0,1):normalize():rotate(math.rad(o.rotOff))
	local fc = center:copy():add(rot:copy():mult(self.padding))
	for i,v in ipairs(self.tris.members) do
		v:setPosition(fc.x, fc.y)
		v:setSize(self.tsize)
		v:setRot((i-1)*180+o.rotOff)
		v.sub:setPosition(fc.x+self.shadowOff, fc.y+self.shadowOff)
		v.sub:setSize(self.tsize)
		v.sub:setRot((i-1)*180+o.rotOff)
		v.st:setPosition(fc.x-v.st.w/2+v.st.centerOff.x, fc.y-v.st.h/2+v.st.centerOff.y)
		v.st:setColor(0,0,0,self.talpha)
		fc = center:copy():add(rot:copy():normalize():rotate(math.rad(-60*i)):mult(self.padding))
	end
end