NameSongMenu = class(Group, function(o, slot_id)
	Group.init(o)
	o:setup()
	o.slot_id = slot_id
end)
function NameSongMenu:setup()
	local o = self
	local i = 1
	o.tris = o:add(Group())
	fs:dofile("/Plains/nameGen.lua")
	o.levelName = getName()
	local fc = Vec2(90*r_scale,60*r_scale)
	local uiData = {['paddingTop']=50*r_scale}
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['subs']={
			{
				['t']='UIlabel';
				['align']='left';
				['text']='choose world';
			},
			{
				['t']='UIspacer';
				['align']='left';
			}
		};
	}
	table.insert(uiData, line)
	local line = {
		['paddingTop']=50*r_scale;
		['t'] = 'UIworldselect';
		['onPress']=function(canvas, world)
			o.currentWorld = world
			if canvas and canvas:getObject('name') then
				o.levelName = getName()
				canvas:getObject('name').text:setValue(o.levelName)
			end
		end;
	}
	table.insert(uiData, line)
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['subs']={
			{
				['id']='name';
				['t']='UIlabel';
				['align']='left';
				['text']=o.levelName;
			},
			{
				['t']='UIbutton';
				['align']='right';
				['text']='rename';
				['onPress']=function(canvas)
					o.levelName = getName()
					canvas:getObject('name').text:setValue(o.levelName)
				end
			},
		};
	}
	table.insert(uiData, line)
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['subs']={
			{
				['t']='UIbutton';
				['align']='right';
				['text']='create';
				['onPress']=function()
					-- open up the editor with this file name. the editor will handle generating the file if it doesn't exist
					player:loadWorldPack(o.currentWorld, nil, function()
						mainState = WrapperState(Group());
						mainState:changeState(SH3EditState(o.levelName, o.slot_id))
					end)
				end
			},
		};
	}
	table.insert(uiData, line)
	local canvas = o:add(UICanvas(uiData))
	WorldSelectMenu.addTopBar(o, 'Name Song', function()
		mainState = WrapperState(Group());
		mainState:changeState(EditSelectMenu())
	end)
end
function NameSongMenu:addTri(fc, world, onPress)
	local o = self
	
	o.rotOff = -19
	o.tsize = 40*r_scale
	o.padding = 120*r_scale

	local t = o.tris:add(TriangleObject(fc.x, fc.y))
	t:setSize(o.tsize)
	t:setRot(self.rotOff)
	t.tsize = o.tsize
	t:setColor(world[2][1], world[2][2], world[2][3])
	t.forceDraw = true

	t.st = o:add(StringObject(fc.x-100*r_scale, fc.y-20*r_scale, world[1], nil, 0.5))
	t.st:setPosition(fc.x-t.st.w/2, fc.y-t.st.h/2)
	t.st:setColor(0,0,0)
	t.onPress = function() onPress(t) end
	fc.x = fc.x+100*r_scale
end
function NameSongMenu:update()
	Group.update(self)
	self.tris:call(function(v)
		v:setSize(v.tsize)
	end)
end
-- mainState = WrapperState(Group());
-- mainState:changeState(NameSongMenu())