PauseState = class(Group, function(o, parent)
  Group.init(o)
  o.parent = parent
  local blackout = o:add(Object(0,0,bludG.camera.w, bludG.camera.h))
  blackout.sprite = sprites['ui']['white.png']
  blackout:setColor(0,0,0,160)
  blackout.drawType = 'stretched'
  -- exit resume remix (if in play mode)
  local p = 20*r_scale
  local resumeIconSpr = sprites['ui']['resume_button.png']
  local playSize = 1
  if r_scale == 4 then
    playSize = 2
  end
  local resumeIcon = o:add(Object(bludG.camera.w-resumeIconSpr:getWidth()-p, p,resumeIconSpr:getWidth()*playSize, resumeIconSpr:getHeight()*playSize))
  resumeIcon.drawType = 'stretched'
  resumeIcon.sprite = resumeIconSpr
  local resumeText = o:add(StringObject(0,0,"play", nil, 0.75))
  resumeText:setPosition(resumeIcon.pos.x-resumeText.w-20*r_scale, p+resumeIcon.h/2-resumeText.h/2)
  local resumeButton = o:add(CameraButton(resumeText.pos.x, p, bludG.camera.w-resumeText.pos.x, resumeIcon.h))
  resumeButton:setColor(0,0,0,0)
  resumeButton.onPress = function()
    mainState:removeState(o)
    parent:unPause()
  end

  p = 3
  local yPos = bludG.camera.h/2-35*r_scale
  local bg = o:add(Object(0,yPos, bludG.camera.w, 35*r_scale))
  bg.sprite = sprites['ui']['white.png']
  bg.drawType = 'stretched'
  bg:setColor(getColor())
  local exitButton = o:add(TiltedCamButton(0,yPos,100*r_scale, 35*r_scale, 'exit'))
  local retryButton = o:add(TiltedCamButton(bludG.camera.w-90*r_scale,yPos,100*r_scale, 35*r_scale, 'retry'))
  exitButton.onPress = function()
    mainState = WrapperState(Group());
    if parent.parent:is_a(LocalSongSelectMenu) then    
      mainState:changeState(LocalSongSelectMenu())
    else
      mainState:changeState(parent.parent)
      if parent.parent.present then parent.parent:present() end
    end
    pd:startList("fromOF")
    pd:addSymbol("startTimer")
    pd:addFloat(player.currentBpm*4)
    pd:finish()
  end

  retryButton.onPress = function()
    mainState:removeState(o)
    parent:unPause()
    parent:restart()
  end

  o:setup()
end)
function PauseState:setup()
  self.score = self:add(self.parent.playOverlay.scoreboard.score)
  self.score:setColor(getYellow())
  self.scoreTxt = self:add(self.parent.playOverlay.scoreboard.scoreTxt)
  self.scoreTxt:setColor(getYellow())
  local uiData = {['paddingTop']=bludG.camera.h/2+35*r_scale}
  -- add a remix button
  if not mainState.substate or not mainState.substate.parent:is_a(SH3EditState) then
    local line = {
      ['t'] = 'UIline';
      ['paddingBottom']=15*r_scale;
      ['subs']={}
    }
    table.insert(line.subs, {
      ['t']='UIbutton';
      ['align']='left';
      ['text']="remix";
      ['onPress']=function()
        mainState:addState(RemixState(self.parent.parseObject, self.parent.songData))
      end
    })
    -- add a link to the leaderboard screen
    if bludParseQuery and gk and gk:isConnected() then
      -- HighscoreState
      table.insert(line.subs, {
        ['t']='UIbutton';
        ['align']='right';
        ['text']="scores";
        ['onPress']=function()
          mainState:addState(HighscoreState(self.parent.parseObject, self.parent.songData))
        end
      })
    end
    table.insert(uiData, line)
  end
  local canvas = self:add(UICanvas(uiData))
end
function PauseState:touchDown(x, y, id)
  Group.touchDown(self, x, y, id)
  return false
end
function PauseState:touchMoved(x, y, id)
  Group.touchMoved(self, x, y, id)
  return false
end
function PauseState:touchUp(x, y, id)
  Group.touchUp(self, x, y, id)
end