
-- a chunk of graphics to throw at the top of the screen during play
PlayOverlay = class(Group, function(o, parent)
	Group.init(o)
	o.parent = parent
	local p = 20*r_scale
	local sprMult = 1
	if r_scale == 4 then
		sprMult = 2
	end
	local pauseSpr = sprites['ui']['pause_button.png']
	-- add a pause graphic
	local pauseGraphic = o:add(Object(bludG.camera.w-p-pauseSpr:getWidth()*sprMult, p, pauseSpr:getWidth()*sprMult, pauseSpr:getHeight()*sprMult))
	pauseGraphic.sprite = pauseSpr
	pauseGraphic.drawType = 'stretched'
	pauseGraphic:setColor(255, 255, 255, 127)
	pauseGraphic.touchDown = CameraButton.touchDown
	pauseGraphic.touchUp = CameraButton.touchUp
	pauseGraphic.fingerDown = {}
	pauseGraphic.fingerCount = 0
	pauseGraphic.noParticle = true
	o.pause = pauseGraphic
	o.pause.onPress = function()
		print('pressed pause')
	end


	local restartSpr = sprites['ui']['restart_button.png']
	-- add a restart graphic
	local restartGraphic = o:add(Object(p, p, restartSpr:getWidth()*sprMult, restartSpr:getHeight()*sprMult))
	restartGraphic.sprite = restartSpr
	restartGraphic.drawType = 'stretched'
	restartGraphic:setColor(255, 255, 255, 127)
	restartGraphic.touchDown = CameraButton.touchDown
	restartGraphic.touchUp = CameraButton.touchUp
	restartGraphic.fingerDown = {}
	restartGraphic.fingerCount = 0
	restartGraphic.noParticle = true
	o.restartBg = restartGraphic
	o.restartBg.onPress = function()
		print('pressed restart')
	end

	o.scoreboard = o:add(ScoreboardState(restartGraphic.pos.x+restartGraphic.w+p/4, restartGraphic.pos.y+6*r_scale))
	o.scoreboard:setScore(1)
	o.restartBg.onPress = function()
		print('pressed restart')
	end
	o:add(HighScoreDisplay(o))
	local bls = sprites['ui']['button_left.png']
	local bl = o:add(Object(p, bludG.camera.h-p-bls:getHeight()*sprMult, bls:getWidth()*sprMult, bls:getHeight()*sprMult))
	bl.sprite = bls
	bl.drawType = 'stretched'
	local brs = sprites['ui']['button_right.png']
	local br = o:add(Object(bludG.camera.w-p-brs:getWidth()*sprMult, bludG.camera.h-p-bls:getHeight()*sprMult, brs:getWidth()*sprMult, brs:getHeight()*sprMult))
	br.sprite = brs
	br.drawType = 'stretched'
	o.buttonLeft = bl
	o.buttonRight = br
end)

function PlayOverlay:setupProgress()
	local fsprite = sprites['ui']['friend_'.. math.random(1,12) ..'.png']
	local padding = 10*r_scale
	self.friend = self:add(Object(bludG.camera.w/2-fsprite:getWidth()/2, bludG.camera.h-fsprite:getHeight()*0.5-padding, fsprite:getWidth()*0.5, fsprite:getHeight()*0.5))
	self.friend.sprite = fsprite
	self.friend.drawType = 'stretched'
	self.totalLoops = self.parent:countLoops()
	self.currentLoop = self.parent.currentLoop
	self.loopCount = self:add(StringObject(self.friend.pos.x, self.friend.pos.y-padding, self.currentLoop .. "/" .. self.totalLoops))
	self:fixProgessPosition()
end
function PlayOverlay:fixProgessPosition()
	local p = 10*r_scale
	local w = self.friend.w+self.loopCount.w+p
	self.friend:setPosition(bludG.camera.w/2-w/2, self.friend.pos.y)
	self.loopCount:setPosition(bludG.camera.w/2+w/2-self.loopCount.w, self.loopCount.pos.y)
end
function PlayOverlay:setPaused()
	self.buttonLeft:setColor(0,0,0,0)
	self.buttonRight:setColor(0,0,0,0)
end
function PlayOverlay:setUnPause()
	self.buttonLeft:setColor(255,255,255,255)
	self.buttonRight:setColor(255,255,255,255)
	self.scoreboard:setUnPause()
end
function PlayOverlay:update()
	Group.update(self)
	-- if not self.setupProgressDone then
	-- 	self:setupProgress()
	-- 	self.setupProgressDone = true
	-- end
	-- if self.currentLoop ~= self.parent.currentLoop then
	-- 	self.currentLoop = self.parent.currentLoop
	-- 	self.loopCount:setValue(self.currentLoop .. "/" .. self.totalLoops)
	-- 	self:fixProgessPosition()
	-- end
end