RemixCompleteState = class(Group, function(o, level)
	Group.init(o)
	o.bg = o:add(Object(0,0,bludG.camera.w,bludG.camera.h))
	o.bg.sprite = sprites['ui']['white.png']
	o.bg.drawType = 'stretched'
	o.bg:setColor(getColor())
	o.bg:setScrollFactor(Vec2(0,0))
	o:setup(level)	
end)
function RemixCompleteState:setup(level)
	local uiData = {['paddingTop']=50*r_scale}
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['subs']={{
					['t']='UIlabel';
					['text']='Copy Complete';
					['align']='left';
				}}
	}
	table.insert(uiData, line)
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['subs']={}
	}
	table.insert(line.subs, {
			['t']='UIbutton';
			['text']='edit now';
			['align']='left';
			['onPress']=function()
				player:loadWorldPack(level.worldPack, nil, function()
					-- wipe the whole screen stack
					mainState = WrapperState(Group());
					mainState:changeState(SH3EditState(level, level.slot_id))
				end)
			end;
		}
	)
	table.insert(line.subs, {
			['t']='UIbutton';
			['text']='ok';
			['align']='right';
			['onPress']=function()
				bludG.camera:zoomTo(0,0,1)
				mainState:removeState(self)
			end;
		}
	)
	table.insert(uiData, line)
	local canvas = self:add(UICanvas(uiData))
end
-- provides an interface for choosing the slot that the remix is going to go into
RemixState = class(Group, function(o, parseObject, songData)
	Group.init(o)
	o.bg = o:add(Object(0,0,bludG.camera.w,bludG.camera.h))
	o.bg.sprite = sprites['ui']['white.png']
	o.bg.drawType = 'stretched'
	o.bg:setColor(getColor())
	o.bg:setScrollFactor(Vec2(0,0))
	o:setup(parseObject, songData)
	WorldSelectMenu.addTopBar(o, 'Remix', function()
		bludG.camera:zoomTo(0,0,1)
		mainState:removeState(o)
	end)
end)
function RemixState:setup(parseObject, songData, parent)
	-- list the slots that you have available on your system with buttons to select one
	local uiData = {['paddingTop']=50*r_scale}
	local levels = fs:enumerate("/player_levels")
	for i=1,player.serverSlots do
		local line = {
			['t'] = 'UIline';
			['c'] = bgc(1);
			['paddingBottom']=15*r_scale;
			['subs']={}
		}
		local level = persistence.load(blud.doc_root .. "/player_levels/level_"..i..".lua");
		if not level then
			table.insert(line.subs, {
					['t']='UIbutton';
					['text']='select';
					['align']='right';
					['onPress']=function()
						-- copy song into this slot
						persistence.store(blud.doc_root .. "/player_levels/level_" .. i .. ".lua", songData);
						remixData = persistence.load(blud.doc_root .. "/player_levels/level_" .. i .. ".lua");
						remixData.filename = "/player_levels/level_" .. i .. ".lua"
						-- clean the data
						cleanedData = {['songData']=remixData}
						local cleanSongData SH3EditState.cleanSongData(cleanedData)
						remixData.loadTutorial = false
						-- need to hard code this in here due to some early bad decisions
						if remixData.worldPack == "guitarzone" then remixData.worldPack = "Plains" end
						-- if this is a song that we are playing from the server, store the parentage information
						if parseObject then
							remixData.parentSong = parseObject:getId()
						end
						remixData.slot_id = i
						persistence.store(blud.doc_root .. "/player_levels/level_" .. i .. ".lua", remixData);
						--  and inform the player that the copy has been made
						mainState:addState(RemixCompleteState(remixData))
						mainState:removeState(self)
						return false
					end;
				}
			)
		else
			table.insert(line.subs, {
					['t']='UIlabel';
					['text']='Slot in use';
					['align']='left';
				}
			)
		end
		table.insert(uiData, line)
	end
	local canvas = self:add(UICanvas(uiData))
end
-- there should be a better way to stop fallthrough
function RemixState:touchDown(x, y, id)
	Group.touchDown(self, x, y, id)
	return false
end
function RemixState:touchMoved(x, y, id)
	Group.touchMoved(self, x, y, id)
	return false
end
function RemixState:touchUp(x, y, id)
	Group.touchUp(self, x, y, id)
	return false
end
