ScoreboardState = class(Group, function(o, x, y)
	Group.init(o)
  local str, stg, stb, sta = 127, 127, 127, 127
  if SynthData.score_txt_tint then
    local st = SynthData.score_txt_tint
    str, stg, stb, sta = st[1], st[2], st[3], st[4]
  end
  
  o.scoreTxt = o:add(StringObject(x, y, "Score", nil, 0.5))
  o.scoreTxt:setColor(str, stg, stb, sta)
	o.score = o:add(StringObject(o.scoreTxt.pos.x+o.scoreTxt.w+5*r_scale, y,"0", nil, 0.5))

  str, stg, stb, sta = 0,0,0,255
  if SynthData.score_tint then
    local st = SynthData.score_tint
    str, stg, stb, sta = st[1], st[2], st[3], st[4]
  end

	o.score:setColor(str, stg, stb, sta)

	o.targetScale = 0.5
	o.multiplier = o:add(StringObject(o.score.pos.x+o.score.w+5*r_scale,0,"1x", nil, o.targetScale))
	o.multiplier:setColor(0,0,0)
	o.updateSpeed = 0.2
	o.updateCount = o.updateSpeed
	o.currentScore = 0
	o.currentMultiplier = 1
	o.targetMultiplier = o.currentMultiplier
	o.targetScore = o.currentScore
	o:setScore(0)
  o.multPad = 6
end)
function ScoreboardState:setScore(newScore)
	self.targetScore = newScore
end
function ScoreboardState:update()
  Group.update(self)
  self.updateCount = self.updateCount - bludG.elapsed
  local hero = mainState.substate.hero.pos
  if self.updateCount <= 0 then
    if self.currentScore ~= self.targetScore then
      if self.targetScore < self.currentScore then
        self.currentScore = self.currentScore - 1
      else
        self.currentScore = self.currentScore + 1
      end
      self.score:setValue(self.currentScore)
    end
    if self.currentMultiplier ~= self.targetMultiplier then
      if self.targetMultiplier < self.currentMultiplier then
        self.currentMultiplier = self.currentMultiplier - 1
      else
        self.currentMultiplier = self.currentMultiplier + 1
      end
      self.multiplier:setColor(r,g,b,255)
      self.multiplier:setValue(self.currentMultiplier .. "x")
    end
  elseif math.abs(self.multiplier.multiplier-self.targetScale) > 0.01 then
      self.multiplier:setValue(self.currentMultiplier .. "x")
  end
  local l_align = 20*r_scale
  self.multiplier:setPosition(self.scoreTxt.pos.x, self.scoreTxt.pos.y+self.scoreTxt.h-self.multPad*r_scale)
end
function ScoreboardState:setMultiplier(newMult)
  self.targetScale = Tweener.equations.easeOutQuad(math.max(0.5, math.min(20, newMult))/20, 0.5, 2, 1)
  if r_scale == 4 then self.targetScale = self.targetScale*2 end
  self.targetMultiplier = newMult
  self.multiplier.multiplier = self.targetScale;
  self.multPad = self.targetScale*6
  local t = SynthData.coin_tint
  self.multiplier:setColor(t[1], t[2], t[3], 255)
  local r,g,b = HSVtoRGB(bludG.last_t, 0.1, 0.5)
  if self.multiplier.colorTween then Tweener:removeTween(self.multiplier.colorTween) end
  self.multiplier.colorTween = Tweener:addTween(self.multiplier.tint, {r=r,g=g,b=b,a=127}, {time=1.25})
end
function ScoreboardState:setUnPause()
  self.scoreTxt:setColor(127,127,127,127)
  self.score:setColor(0,0,0)
end
function ScoreboardState:jumpToTarget()
	self.multiplier.multiplier = self.targetScale
	self.currentScore = self.targetScore
	self.currentMultiplier = self.targetMultiplier
	self.score:setValue(self.currentScore)
	self.multiplier:setValue(self.currentMultiplier .. "x")
end
function ScoreboardState:draw()
	if not chunkCamera then chunkCamera = Camera(0,0,bludG.camera.w, bludG.camera.h) end
	self.score:draw()
  self.scoreTxt:draw()
	if self.targetMultiplier>5 then
		chunkCamera.scroll.x = (math.random()*8-4)*r_scale
		chunkCamera.scroll.y = (math.random()*8-4)*r_scale
		self.multiplier:setCamera(chunkCamera)
		self.multiplier:draw()
	end
	self.multiplier:setCamera(bludG.camera)
	self.multiplier:draw()
end
-- mainState = WrapperState(Group());
-- mainState:changeState(PlayOverlay())
