SettingState = class(Group, function(o, song, id)
	Group.init(o)
	o.song = song
	o.id = id
	local uiData = {['paddingTop']=100*r_scale}
	if song then
		o.song.slot_id = o.id
		local line = {
			['t'] = 'UIline';
			['c'] = bgc(1);
			['paddingBottom']=35*r_scale;
			['subs']={
				{
					['t']='UIbigworld';
					['align']='left';
					['text']=song.name;
					['world']=getWorldFromName(song.worldPack);
				}
			};
		}
		table.insert(uiData, line)
	end
	if song then
		local line = {
			['t'] = 'UIline';
			['c'] = bgc(1);
			['paddingBottom']=15*r_scale;
			['subs']={
				{
					['t']='UIbutton';
					['align']='right';
					['text']="delete";
					['onPress']=function()
						mainState:addState(ConfirmState(function()
							fs:rm("/player_levels/level_" .. id .. ".lua")
							mainState = WrapperState(Group());
							mainState:changeState(EditSelectMenu())			
						end, function()
						end, "Are you sure?"))
					end;
				}
			};
		}
		table.insert(uiData, line)
	end
	if song then
		if bludParseQuery and gk and gk:isConnected() then
			o:addLeaderboardLink(uiData)
		end
		if bludParseQuery and gk and gk:isConnected() then
			o:addServerSaveButton(uiData)
		end
	end
	if bludParseQuery and gk and gk:isConnected() then
		o:addServerDownloadButton(uiData)
	end
	if #uiData == 0 then
		local line = {
			['t'] = 'UIline';
			['c'] = bgc(1);
			['paddingBottom']=15*r_scale;
			['subs']={
				{
					['t']='UIlabel';
					['align']='left';
					['text']="create a level or go online for more options";
				}
			};
		}
		table.insert(uiData, line)		
	end
	local canvas = o:add(UICanvas(uiData))
	SongSelectMenu.setupDragArea(o, canvas.h)
	WorldSelectMenu.addTopBar(o, 'settings', function()
		mainState = WrapperState(Group());
		mainState:changeState(EditSelectMenu())
	end)
end)
function SettingState:addLeaderboardLink(uiData)
	local o = self
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['subs']={
			{
				['t']='UIlabel';
				['align']='left';
				['text']="view leaderboards";
			},
			{
				['t']='UIbutton';
				['align']='right';
				['text']="go";
				['onPress']=function()
					-- pop a loading screen
					self.savingOverlay = self:add(LoadingState("checking server"))
					local pquery = bludParseQuery("PlayerLevel")
					pquery:whereKeyEquals("userId", gk:getId())
					pquery:whereKeyEquals("slot_id", self.id)
					pquery:findObjects(function(objects, errorCode)
						self:remove(self.savingOverlay)
						if not objects then
							-- server fail, inform user
							local errorText = "error"
							if type(errorCode) == 'string' then
								errorText = errorText .. ": " .. errorCode
							else
								errorText = errorText .. " code: " .. errorCode
							end
							mainState:addState(ErrorState(function()					
							end, errorText))
						elseif #objects > 0 then
							-- load the highscore screen for this level
							mainState:addState(HighscoreState(objects[1], nil))
						elseif #objects == 0 then
							-- server fail, inform user
							local errorText = "level not found on server"
							mainState:addState(ErrorState(function()	
							end, errorText))
						end
					end)
				end;
			}
		};
	}
	table.insert(uiData, line)
end
function SettingState:addServerDownloadButton(uiData)
	local o = self
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['subs']={
			{
				['t']='UIlabel';
				['align']='left';
				['text']="get version from server";
			},
			{
				['t']='UIbutton';
				['align']='right';
				['text']="download";
				['onPress']=function()
					self.savingOverlay = self:add(LoadingState("downloading"))
					DownloadSongFromServer(self.id, function()
						-- reload the song from the data, redisplay this menu
						local song = persistence.load(blud.doc_root .. "/player_levels/level_"..self.id..".lua");

						mainState = WrapperState(Group());
						mainState:changeState(SettingState(song, self.id))
					end)
				end;
			}
		};
	}
	table.insert(uiData, line)
end
function SettingState:addServerSaveButton(uiData)
	local o = self
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['paddingBottom']=15*r_scale;
		['subs']={
			{
				['t']='UIbutton';
				['align']='right';
				['text']="upload";
				['onPress']=function()
					self.savingOverlay = self:add(LoadingState("saving"))
					UploadSongToServer(self.song, function()
						self:remove(self.savingOverlay)
					end)
				end;
			}
		};
	}
	table.insert(uiData, line)
end
function SettingState:addTri(fc)
	local o = self
	local t = self:add(TriangleObject(fc.x, fc.y))
	o.rotOff = -19
	o.tsize = 60*r_scale
	o.padding = 120*r_scale
	t:setSize(self.tsize)
	t:setRot(self.rotOff)

	t:setColor(self.world[2][1], self.world[2][2], self.world[2][3])
	t.forceDraw = true

	t.st = o:add(StringObject(fc.x-100*r_scale, fc.y-20*r_scale, self.song.name, nil, 0.5))
	t.st:setColor(0,0,0)
	t.st:setPosition(80*r_scale, fc.y)
	t.onPress = onPress
	fc.y = fc.y+20*r_scale
end
function DownloadSongFromServer(id, callback)
	-- determine the file that we are working on
	local pquery = bludParseQuery("PlayerLevel")
	pquery:whereKeyEquals("userId", gk:getId())
	pquery:whereKeyEquals("slot_id", id)
	pquery:findObjects(function(objects, errorCode)
		if not objects then
			-- server fail, inform user
			local errorText = "error"
			if type(errorCode) == 'string' then
				errorText = errorText .. ": " .. errorCode
			else
				errorText = errorText .. " code: " .. errorCode
			end
			mainState:addState(ErrorState(function()					
				callback()
			end, errorText))
		elseif #objects > 0 then
			-- extract the song from the object
			local song = persistence.loadFromString(objects[1]:getObject("levelData"))
			-- write file to filesystem
			persistence.store(blud.doc_root .. "/player_levels/level_" .. id .. ".lua", song);
			callback()
		elseif #objects == 0 then
			-- server fail, inform user
			local errorText = "not found on server"
			mainState:addState(ErrorState(function()	
				callback()				
			end, errorText))
		end
	end)
end
local noGC = {}
function UploadSongToServer(song, callback)
	-- determine the file that we are working on
	local levelText = fs:getString(song.filename)
	local pquery = bludParseQuery("PlayerLevel")
	pquery:whereKeyEquals("userId", gk:getId())
	pquery:whereKeyEquals("slot_id", song.slot_id)
	pquery:findObjects(function(objects, errorCode)
		local pobj
		if not objects then
			-- server fail, inform user
			local errorText = "error"
			if type(errorCode) == 'string' then
				errorText = errorText .. ": " .. errorCode
			else
				errorText = errorText .. " code: " .. errorCode
			end
			mainState:addState(ErrorState(function()					
			end, errorText))
			callback()
		elseif #objects == 0 then
			pobj = bludParseObject("PlayerLevel")
			-- should determine if there are any existing levels with this name and username yet
			pobj:setObject(song.name, "levelName")
			pobj:setObject(song.worldPack, "worldPack")
			pobj:setObject(gk:getAlias(), "userAlias")
			pobj:setObject(gk:getId(), "userId")
			pobj:setObject(song.slot_id, "slot_id")
			pobj:setObject("gamecenter", "portal")
			pobj:setObject(levelText, "levelData")
			if song.parentSong then
				pobj:setObjectWithClassAndId("PlayerLevel", song.parentSong, "parent")
			end
			pobj:save(function(saved)
				callback()
			end)
		elseif objects[1] then
			local originalLevel = objects[1]
			mainState:addState(ConfirmState(function()
				local pobj = bludParseObject("PlayerLevel")
				-- should determine if there are any existing levels with this name and username yet
				pobj:setObject(song.name, "levelName")
				pobj:setObject(song.worldPack, "worldPack")
				pobj:setObject(gk:getAlias(), "userAlias")
				pobj:setObject(gk:getId(), "userId")
				pobj:setObject(song.slot_id, "slot_id")
				pobj:setObject("gamecenter", "portal")
				pobj:setObject(levelText, "levelData")
				if song.parentSong then
					pobj:setObjectWithClassAndId("PlayerLevel", song.parentSong, "parent")
				end
				pobj:save(function(saved)
					if saved then
						originalLevel:deleteEventually()
					end
					callback()
				end)
			end, function()
				callback()
			end, "Are you sure you want to overwrite? Will remove all plays and likes."))
		end
	end)
end
-- song = mainState.substate.song
-- mainState = WrapperState(Group());
-- mainState:changeState(SettingState(song))
