--[[

	toplevel
		web levels
			show all
		edit
			choose existing edit level
				edit screen
			make new
				choose world
					choose name
						edit screen
		play
			choose world
				choose level
--]]
function getColor()
	return 243, 242, 236
end
TopLevelMenu = class(Group, function(o)
	bludG.camera:zoomTo(0,0,1)
	bg:setBackground(getColor())
	Group.init(o)
	o:add(BackgroundWaves())
	o.outerSize = 100*r_scale
	o.outer = o:add(TriangleObject(bludG.camera.w/2, bludG.camera.h/2))
	o.outer:setColor(0,0,0)
	o.outer:setSize(o.outerSize)
	o.eyeBits = o:add(Group())
	o.eyeScale = 1
	local e = o.eyeBits:add(CenteredObject(bludG.camera.w/2, bludG.camera.h/2, 10, 10))
	e.sprite = sprites['ui']['circle.png']
	e.rootscale = 1.1
	e:setColor(getColor())

	e = o.eyeBits:add(CenteredObject(bludG.camera.w/2, bludG.camera.h/2, 10, 10))
	e.sprite = sprites['ui']['circle.png']
	e.rootscale = .98
	e:setColor(0,0,0)

	e = o.eyeBits:add(CenteredObject(bludG.camera.w/2, bludG.camera.h/2, 10, 10))
	e.sprite = sprites['ui']['circle.png']
	e.rootscale = .96
	e:setColor(getColor())

	e = o.eyeBits:add(CenteredObject(bludG.camera.w/2, bludG.camera.h/2, 10, 10))
	e.sprite = sprites['ui']['circle.png']
	e.rootscale = .6
	e:setColor(0,0,0)
	
end)
function TopLevelMenu:update()
	Group.update(self)
	for i,v in ipairs(self.eyeBits.members) do
		v.scale = v.rootscale*self.eyeScale
	end
	self.outer:setSize(self.outerSize)
	self.outer:setRot(bludG.last_t*100)

end
function TopLevelMenu:touchDown()
	if not self.touched then
		Tweener:addTween(self, {outerSize=0}, {time=.5, func='outSine'})
		Tweener:addTween(self, {eyeScale=0}, {func='outBounce', time=1.2, onComplete=function()
			mainState:removeState(self)
		end})
		mainState:addState(ModeMenu())
	end
	self.touched = true
end