TopRatedSongs = class(SongSelectMenu, function(o)
	SongSelectMenu.init(o)
end)
function TopRatedSongs:setup()
	-- do a subquery to get the most recent 100 levels or so
	self.currentPage = 0;
	self.songButtons = self:add(Group())
	self:getData()
	WorldSelectMenu.addTopBar(self, 'choose song', function()
		mainState = WrapperState(Group());
		mainState:changeState(GlobeModeMenu())
	end)
end
local noGC = {}
function TopRatedSongs:getData()
	local secondsInDay = 60*60*24
	local pquery = bludParseQuery("PlayerLevel")	
	pquery:whereKeyGreaterThanDate("updatedAt", os.time()-secondsInDay*(14*(self.currentPage+1)))
	pquery:whereKeyLessThanDate("updatedAt", os.time()-secondsInDay*(14*self.currentPage))
	pquery:whereKeyExists("likeCount")
	pquery:addDescendingOrder("likeCount")
	pquery:limit(30)
	noGC[pquery] = pquery
	-- should throw up a loading from server screen here
	self.loadingOverlay = self:add(LoadingState(nil, function()
		pquery:cancel();
		noGC[pquery]=nil
		bludG.camera:zoomTo(0,0,1)
		self:remove(self.loadingOverlay)
	end))	
	pquery:findObjects(function(objects, errorCode)
		local display = function()
			noGC[pquery] = nil
			self:remove(self.loadingOverlay)
			if not objects then
				local errorText = "error"
				if type(errorCode) == 'string' then
					errorText = errorText .. ": " .. errorCode
				else
					errorText = errorText .. " code: " .. errorCode
				end
				mainState:addState(ErrorState(function()
					-- press the back button
					mainState = WrapperState(Group());
					mainState:changeState(GlobeModeMenu())
				end, errorText))
			else
				self:addSongButtons(objects)
			end
		end
		display()
	end)
end
function TopRatedSongs:addSongButtons(objects)
	local uiData = {['paddingTop']=50*r_scale}
	local topline = {
		['t'] = 'UIline';
		['paddingBottom']=15*r_scale;
		['subs']={}
	}
	if self.currentPage>0 then
		table.insert(topline.subs, {
			['t']='UIbutton';
			['align']='right';
			['text']="newer";
			['onPress']=function()
				self.currentPage = self.currentPage-1
				self:getData()
			end;
		})
	end
	table.insert(topline.subs, {
		['t']='UIbutton';
		['align']='right';
		['text']="older";
		['onPress']=function()
			self.currentPage = self.currentPage+1
			self:getData()
		end;
	})
	table.insert(uiData, topline)
	for i,v in ipairs(objects) do
		local ld = assert(loadstring(v:getObject("levelData")))()
		local line = {
			['t'] = 'UIline';
			['paddingBottom']=15*r_scale;
			['subs']={}
		}
		table.insert(line.subs, {
			['t']='UIlabel';
			['align']='left';
			['text']=v:getObject("userAlias");
		})
		table.insert(line.subs, {
				['t']='UIspacer';
				['c']={getColor()};
				['align']='left';
			}
		)
		table.insert(line.subs, {
			['t']='UIlabel';
			['align']='left';
			['text']=v:getObject('likeCount');
		})
		table.insert(line.subs, {
				['t']='UIspacer';
				['c']={getColor()};
				['align']='left';
			}
		)
		table.insert(line.subs, {
			['t']='UIlabel';
			['align']='left';
			['text']=ld.name;
		})
		table.insert(line.subs, {
			['t']='UIbutton';
			['text']='play';
			['align']='right';
			['onPress']=function()
				-- check to see if the song exists on the player model, if not create it
				if not player.songs[ld] then
					player.songs[ld] = {{}}
				end
				player:loadWorldPack(ld.worldPack, nil, function()				
					player.currentSong = ld
					mainState = WrapperState(Group());
					mainState:changeState(SpaceHero3(ld, v, self))
				end)
			end
		})
		table.insert(uiData, line)
	end
	if #objects == 0 then
		local line = {
			['t'] = 'UIline';
			['paddingBottom']=15*r_scale;
			['subs']={}
		}
		table.insert(line.subs, {
			['t']='UIlabel';
			['align']='left';
			['text']="no top rated levels found for this time period";
		})
		table.insert(uiData, line)
	end
	if self.canvas then self.songButtons:remove(self.canvas) end
	self.canvas = self.songButtons:add(UICanvas(uiData))
	self:setupDragArea(self.canvas.h)
end