TurnShotGameOver = class(Group, function(o, parent, text)
	Group.init(o)
	o.parent = parent
	o.parent.gameOver = true
	o.frameCount = 0
	o.restartCount = 0
	-- to support game over replay
	o:setupReplay()
	local textObj = o:add(StringObject(0,0,text))
	textObj:setPosition(bludG.camera.w/2-textObj.w/2, bludG.camera.h/2-textObj.h/2)
	textObj:setColor(0,0,0)
	-- hide the parents bullets and players, for a clean replay
	o.parent:remove(o.parent.bullets)
	o.parent:remove(o.parent.players)

end)
function TurnShotGameOver:setupReplay()
	local o = self
	self.frameCount = 0
	if o.bullets then self:remove(self.bullets) end
	if o.players then self:remove(self.players) end
	o.bullets = o:add(Group())
	o.players = o:add(Group())
	o.p1 = o.players:add(Player(bludG.camera.w/3, bludG.camera.h/2))
	o.p1:setColor(230, 100, 100)
	o.p2 = o.players:add(Player(bludG.camera.w/3*2, bludG.camera.h/2))
	o.p2:setColor(100, 100, 230)
end
function TurnShotGameOver:touchDown(x, y, id)
	Group.touchDown(self, x, y, id)
	if self.restartCount > 3*60 then
		local tsState = TurnShotState(self.parent.gkMatch)
		mainState = WrapperState(Group());
		mainState:changeState(tsState)
	end
	return false
end
function TurnShotGameOver:touchMoved(x, y, id)
	Group.touchMoved(self, x, y, id)
	return false
end
function TurnShotGameOver:touchUp(x, y, id)
	Group.touchUp(self, x, y, id)
	return false
end
function TurnShotGameOver:update()
	Group.update(self)
	-- print(self.frameCount)
	self.restartCount = self.restartCount + 1
	if self.parent.replay[self.frameCount] then
		self.moves = {
			[self.p1]=self.parent.replay[self.frameCount][1];
			[self.p2]=self.parent.replay[self.frameCount][2];
		}
		TurnShotState.commitMoves(self)
	end
	self.players:call(function(p)
		p.pos:add(p.vel)
		p.vel:mult(0.99)
		bounceToScreen(p)
	end)
	self.bullets:call(function(p)
		p.pos:add(p.vel)
		-- bounceToScreen(p)
		p.age = p.age+1
	end)
	self.frameCount = self.frameCount + 1
	if self.frameCount > self.parent.frameCount then
		self:setupReplay()
	end
end