TutorialOverlay = class(Group, function(o, parent)
	Group.init(o)
	o.parent = parent
	-- load in the svgs that will be displayed
	o.tut1 = SvgLoader(svg_root .. "interface/tutorial_screen_1".. ipad ..".svg", true)
	o.tut2 = SvgLoader(svg_root .. "interface/tutorial_screen_2".. ipad ..".svg", true)
	o.tut3 = SvgLoader(svg_root .. "interface/tutorial_screen_3".. ipad ..".svg", true)
	o.tut4 = SvgLoader(svg_root .. "interface/tutorial_screen_4".. ipad ..".svg", true)
	o.tutorialDisplay = o:add(Object(0,0,bludG.camera.w,bludG.camera.h))
	o.tutorialDisplay.drawType = 'svg'
	o.tutorialDisplay.svg = o.tut1
	o.state = '1'
end)
function TutorialOverlay:update()
	Group.update(self)
	if self.state == '1' then
		self.parent.noClear = true
		self.parent.hero.autofly = true
	end
	if self.state == '2' and self.parent.currentLoop >= 4 then
		self.tutorialDisplay.svg = self.tut3
		self.state = '3'
	end
	if self.state == '4' and self.parent.currentLoop == 8 then
		self.tutorialDisplay.svg = self.tut4
		self.state = '5'
		self.tutorialDisplay:setColor(255,255,255,255)
	end
	if self.state == '5' and self.parent.currentLoop == 11 then
		self:remove(self.tutorialDisplay)
		self.state = '6'
	end
end
function TutorialOverlay:touchDown(x, y, id)
	if self.state == '1' then
		if x > bludG.camera.w/2 then
			self.state = '2'
			self.tutorialDisplay.svg = self.tut2
			self.parent.noClear = false
			self.parent.hero.autofly = false
			return true
		else
			return false
		end
	elseif self.state == '3' then
		if x < bludG.camera.w/2 then
			self.state = '4'
			self.tutorialDisplay:setColor(0,0,0,0)
		end
	end
end
function TutorialOverlay:touchMoved(x, y, id)
	if self.state == '1' then
		return false
	end
end
function TutorialOverlay:touchUp(x, y, id)
	if self.state == '1' then
		return false
	end
end

IntroControl = class(Group, function(o, parent)
	Group.init(o)
	o.parent = parent
	o.state = '1'
end)
function IntroControl:update()
	Group.update(self)
	if self.state == '1' then
		self.parent.noClear = true
		self.parent.noBurn = true
		self.parent.hero.autofly = true
	end
end
function IntroControl:touchDown(x, y, id)
	if self.state == '1' then
		-- self:remove(self.tutorialDisplay)
		self.state = '2'
		self.parent.noBurn = false
		self.parent.noClear = false
		self.parent.hero.autofly = false
		return true
	end
end
function IntroControl:touchMoved(x, y, id)
	if self.state == '1' then
		return false
	end
end
function IntroControl:touchUp(x, y, id)
	if self.state == '1' then
		return false
	end
end