function getYellow()
	return 242, 208, 73
end
WinOverlay = class(Group, function(o, coincount, parseObject, songData, parent)
	o.parent = parent
	Group.init(o)
	local blackout = o:add(Object(0,0,bludG.camera.w, bludG.camera.h))
	blackout.sprite = sprites['ui']['white.png']
	blackout:setColor(0,0,0,160)
	blackout.drawType = 'stretched'
	blackout:setScrollFactor(Vec2(0,0))

	o:setup(coincount, parseObject, songData, parent)
end)
function WinOverlay:setup(coincount, parseObject, songData, parent)
	local leftMargin = 100*r_scale
	local p = 6*r_scale
	local o = self
	local spos = Vec2(120*r_scale, 70*r_scale)
	self.toCall = {}
	-- add in the background line, and text
	-- check to see what tris are new and which are already unlocked
	-- -- pop in the new scores if we have them
	o.poppingTris = o:add(Group())

	-- add in the two score lines
	spos.y = spos.y + 80*r_scale
	
	self.scoreBg = self:add(TiltedRect(leftMargin, 70*r_scale, bludG.camera.w, 35*r_scale))
	self.scoreBg.sprite = sprites['ui']['white.png']
	self.scoreBg:setColor(0,0,0)
	self.scoreLabel = self:add(StringObject(self.scoreBg.pos.x+p, self.scoreBg.pos.y+self.scoreBg.h/2-16*r_scale, "score:", nil, 0.75))	
	self.scoreLabel:setColor(getYellow())
	local scoreItems = StringObject(self.scoreLabel.pos.x+self.scoreLabel.w+p, self.scoreBg.pos.y+self.scoreBg.h/2-30*r_scale, coincount, nil, 3)
	self.scoreDisplay = Group()
	for i,v in ipairs(scoreItems.subs) do
		self.scoreDisplay:add(v)
		v.oy = v.pos.y
	end
	local highScoreNum = player:storeHighscore(coincount, parseObject, songData)
	if self.setupBottomButtons then self:setupBottomButtons() end
	if not parseObject and not self.parent.parent:is_a(SH3EditState) then
		o:addTris(coincount, parseObject, songData)
	end
	if parseObject then
		o:addLevelStatLine(parseObject)
	end
	if highScoreNum == coincount then
		local popHighScore
		popHighScore = function()
 			playEffectNew('personalHighScore')
			bludG.camera:shake(0.3)
			local hss = sprites['ui']['high_score_icon.png']
			self.highscore = self:add(CenteredObject(self.scoreBg.pos.x-hss:getWidth()/2-p, self.scoreBg.pos.y+self.scoreBg.h/2, hss:getWidth(), hss:getHeight()))
			self.highscore.sprite = hss
			self.highscore.scale = 0
			local p = mainState.particles:addRecycle(ParticleHandler(self.highscore.pos.x, self.highscore.pos.y, "particle_data_explosion.lua",
			sprites['ui']['triangle.png'],
			{
				lifetime=1,
				numParticles=40,
				sheet=sheets['ui']
			}))
			addHalo(self.highscore.pos)
			p.pl.particles:add(40)
			self.highscore.scaleTween = Tweener:addTween(self.highscore, {scale=1}, {time=1.5, func='outElastic', onComplete=function()
				self:removeFromCallQueue(popHighScore)
				self.highscore.scaleTween = nil
			end})
		end
		table.insert(self.toCall, popHighScore)
	end
	-- if we arn't editing, then get the highscore from the server
	if not self.parent.parent:is_a(SH3EditState) then
		WinScreenData(parseObject, songData, coincount, function(user, ghighscore)
			local uiData = {['paddingTop']=spos.y}
			local highscoretext = user .. ": " .. ghighscore
			local line = {
				['t'] = 'UIline';
				['c'] = bgc(1);
				['paddingBottom']=15*r_scale;
				['subs']={
					{
						['t']='UIlabel';
						['align']='left';
						['text']='global highscore';
					},
					{
						['t']='UIspacer';
						['align']='left';
					},
					{
						['t']='UIlabel';
						['align']='left';
						['id']='globalHighScoreText';
						['text']=highscoretext;
					},
					{
						['t']='UIbutton';
						['align']='right';
						['text']='scores';
						['onPress']=function()
							mainState:addState(HighscoreState(parseObject, songData))
						end
					},
				};
			}
			table.insert(uiData, line)
			local canvas = o:add(UICanvas(uiData))
			if coincount > ghighscore then
				local startTime = bludG.last_t
				local explodeOldScore = function()
					while bludG.last_t - startTime < 1 do
						coroutine.yield()
					end
					bludG.camera:shake(0.3)
					local label = canvas:getObject("globalHighScoreText")
					for j,letter in ipairs(label.text.subs) do
						local l = mainState.particles:addRecycle(DeathSpin(letter.pos.x+letter.w/2, letter.pos.y+letter.h/2, letter.sprite, letter.tint, letter.sheet, 0))
					end
		 			playEffectNew('globalHighScore')
		 			label.text:setValue(gk:getAlias() .. ": " .. coincount)
	 			end
				table.insert(runningCoroutines, coroutine.create(explodeOldScore))
			end
		end)
	end
	-- add in the bottom replay / exit buttons
	o.frp = function()
		o:addReplayButton()
		o:removeFromCallQueue(o.frp)
	end
	table.insert(self.toCall, o.frp)
	self:callNext()
end
function WinOverlay:addLevelStatLine(parseObject)
	WinScreenData.hasUserLiked(self, parseObject, function(liked, e)
		if not e then
			self:addLevelStatLineWithLike(parseObject, liked)
		end
	end)
end
function WinOverlay:addLevelStatLineWithLike(parseObject, liked)
	if self.statLine then self:remove(self.statLine) end
	local uiData = {['paddingTop']=0}
	local pc = parseObject:getObject("playCount") or 1		
	local line = {
		['t'] = 'UIline';
		['c'] = bgc(1);
		['id'] = 'statLine';
		['paddingBottom']=15*r_scale;
		['subs']={
			{
				['t']='UIlabel';
				['align']='left';
				['text']="plays: "..pc;
			},
		};
	}
	if not liked then
		table.insert(line.subs, {
			['t']='UIbutton';
			['align']='right';
			['text']='like+';
			['onPress']=function()
				self.savingOverlay = self:add(LoadingState("saving like"))
				WinScreenData.voteUpLevel(self, parseObject, function(e)
					self:remove(self.savingOverlay)
					if e then
						mainState:addState(ErrorState(function()					
						end, "could not save like"))
					else
						self:addLevelStatLineWithLike(parseObject, true)
					end
				end)
				return false
			end
		})
	else
		table.insert(line.subs, {
			['t']='UIbutton';
			['align']='right';
			['text']='liked';
			['onPress']=function()
 			end
		})		
	end
	table.insert(uiData, line)
	self.statLine = self:add(UICanvas(uiData))
	WinScreenData.countLikes(self, parseObject, function(count)
		local line = self.statLine:getObject('statLine')
		line:addSub({
			['t']='UIspacer';
			['align']='left';
		})
		line:addSub({
			['t']='UIlabel';
			['align']='left';
			['text']="likes: "..count;
		})
	end)
end
function WinOverlay:addTris(coincount, parseObject, songData)
	local triInfo, percentageInfo, targetInfo = player:storeTris(coincount, parseObject, songData)
	local o = self
	local lastNum = self.scoreDisplay.members[#self.scoreDisplay.members]
	local spos = Vec2(lastNum.pos.x+lastNum.w+50*r_scale, 100*r_scale)
	-- add in the background triangles
	for i=1,3 do
		local t = o:add(TriangleObject(spos.x, spos.y))	
		t:setSize(22*r_scale)
		t:setColor(0,0,0)
		t:setRot(-19)
		-- add in an overlay if we already have the star for this level
		if triInfo and triInfo[i] == 'unlocked' then
			local t = o:add(TriangleObject(spos.x-7*r_scale, spos.y-3*r_scale))	
			t:setSize(20*r_scale)
			t:setColor(getYellow())
			t:setRot(-19)
		end
		spos.x = spos.x+35*r_scale
	end
	spos.x = spos.x-(35*r_scale)*3
	-- pop in the new scores if we have them
	o.poppingTris = o:add(Group())
	local toPop = {}
	local showedArc = false
	local numUnlocked = 0
	local nexttriat
	for i,v in ipairs(triInfo) do
		if v == 'newUnlock' then
			table.insert(toPop, {i, 1.0})
		elseif v == 'locked' and not showedArc then
			showedArc = true
			table.insert(toPop, {i, percentageInfo[i]})
			nexttriat = targetInfo[i]
		end
		if v == 'newUnlock' or v == 'unlocked' then
			numUnlocked = numUnlocked+1
		end
	end
	if numUnlocked<3 and nexttriat then
		local nexttri = o:add(StringObject(spos.x-10*r_scale,spos.y-52*r_scale,"next tri at " .. nexttriat, nil, 0.5))
		nexttri:setColor(getYellow())
	end
	self:popTri(toPop, spos)
end
function WinOverlay:setupBottomButtons()
	local o = self
	o.bottomBar = o:add(Object(0,bludG.camera.h/9*8,bludG.camera.w, bludG.camera.h/9))
	o.bottomBar.sprite = sprites['bg']['white.png']
	o.bottomBar.sheet = sheets['bg']
	o.bottomBar.drawType = 'stretched'
	o.bottomBar:setColor(getColor())
	local exitButton = o:add(TiltedCamButton(0,bludG.camera.h/9*8,100*r_scale, 35*r_scale, 'exit'))
	exitButton.onPress = function()
	    mainState = WrapperState(Group());
		if self.parent.parent:is_a(LocalSongSelectMenu) then    
			mainState:changeState(LocalSongSelectMenu())
		else
			mainState:changeState(self.parent.parent)
			if self.parent.parent.present then self.parent.parent:present() end
		end
	end
end
function WinOverlay:addReplayButton()
	local o = self
	local replayButton = o:add(TiltedCamButton(bludG.camera.w-100*r_scale+8*r_scale,bludG.camera.h/9*8,100*r_scale, 35*r_scale, 'replay'))
	replayButton.onPress = function()
		o.parent:fullRestart()
	end
end
function WinOverlay:popTri(toPop, spos)
	if #toPop == 0 then return end
	-- i represents the star number we are adding
	local i = #toPop
	for i,v in ipairs(toPop) do
		print(i,v[1], v[2])
	end
	local popFuncs = {}
	while toPop[i] ~= nil do
		local count = i
		if toPop[i][2] == 1 then
			popFuncs[i] = function()
				playEffectNew('showingTri')
				local nextPop = count+1
				self.poppingTris:add(SmashTri(-10, spos.y-7*r_scale, spos.x-3*r_scale+(35*r_scale)*(toPop[count][1]-1), spos.y-7*r_scale, {
					onComplete=function()
						playEffectNew('hitTri')
						if popFuncs[nextPop] then
							Tweener:addTween(self, {}, {time=0.5, onComplete=popFuncs[nextPop]})
						else
							self:removeFromCallQueue(popFuncs[1])
						end
					end
				}))
			end
		else
			popFuncs[i] = function()
				playEffectNew('showingArc')
				local nextPop = count+1
				local cPos = Vec2(spos.x-3*r_scale+(35*r_scale)*(toPop[count][1]-1), spos.y-7*r_scale)
				local triLine = self.poppingTris:add(TriangleOutlineObject(cPos.x, cPos.y))
				triLine.line.w = 2
				triLine:setRot(-19)
				triLine:setSize(20*r_scale)
				triLine.line:setColor(getYellow())
				Tweener:addTween({}, {}, {onComplete=function()
					if popFuncs[nextPop] then
						Tweener:addTween(self, {}, {time=0.5, onComplete=popFuncs[nextPop]})
					else
						self:removeFromCallQueue(popFuncs[1])
					end
				end})
			end			
		end
		i = i-1
	end
	if popFuncs[1] then
		table.insert(self.toCall, popFuncs[1])
	end
end
function WinOverlay:removeFromCallQueue(o)
	print('attempting to remove', o, table.maxn(self.toCall))
	for i=table.maxn(self.toCall),1,-1 do
		if self.toCall[i] == o then
			print("removed", i)
			table.remove(self.toCall, i);
			break;
		end
	end
	print(self.toCall[1])
	if self.toCall[1] then
		self:callNext()
	end
end
function WinOverlay:callNext()
	if self.toCall[1] then self.toCall[1]() end
end
function WinOverlay:update()
	Group.update(self)
	if self.highscore then 
		self.highscore.rot = bludG.last_t*100
		if not self.highscore.scaleTween then
			self.highscore.scale = 1+math.sin(bludG.last_t*2)*0.2
		end
	end
end
function WinOverlay:draw()
	Group.draw(self)
	local count=0
	self.scoreDisplay:call(function(v)
		for i=1,3 do
			local r,g,b = 255, 255, 255
			local lp = (i-1)/2
			r,g,b = r*lp,g*lp,b*lp
			v:setPosition(v.pos.x, v.oy-math.sin((bludG.last_t+i*0.1+count*0.1)*5)*10*r_scale)
			v:setColor(r,g,b)
			v:draw()			
		end
		count = count+1
	end)	
end