WorldSelectMenu = class(Group, function(o, worldSelectFunc)
	bludG.camera:scrollTo(0,0)
	Group.init(o)
	o.rotOff = -19
	o.tsize = 50*r_scale
	o.padding = 120*r_scale
	-- this will need to be loaded from data eventually
	o.worlds = WorldData
	if worldSelectFunc == nil then
		worldSelectFunc = function(v)
			return function()
				player:loadWorldPack(v[3], nil, function()
					mainState = WrapperState(Group());
					mainState:changeState(SongSelectMenu(true))
				end)
			end
		end
	end
	local center = Vec2(o.tsize, bludG.camera.h/2)
	local rot = Vec2(0,1):normalize():rotate(math.rad(o.rotOff))
	local fc = center:copy()
	o.subTris = o:add(Group())
	o.tris = o:add(Group())
	for i,v in ipairs(o.worlds) do
		o:addTri(fc, i, v, worldSelectFunc(v))
		fc = center:add(Vec2(o.padding, 0))
	end
	o:addTopBar('choose world', function()
		mainState = WrapperState(Group());
		mainState:changeState(ModeMenu())
	end)
	o:setupDragArea()
end)
function WorldSelectMenu:setupDragArea()
	local o = self
	o.drag = o:add(DragArea(0,0,bludG.camera.w, bludG.camera.h))
	o.drag.onStart = function(da,x,y,id)
		o.moveAmt = Vec2(0,0)
	end
	o.drag.onMove = function(da,x,y,id)
		WorldSelectMenu.panModeHandler(o, da, x, y, id)
	end
	o.drag.onPress = function(da,x,y,id) 
		if o.moveAmt:length()<5*r_scale then
			return true
		end
		return false
	end
	o.drag.scrollFactor = Vec2(0,0)
end
function WorldSelectMenu:panModeHandler(da, x, y, id)
	local p = Vec2(x, y)
	p:sub(da.lastPos[id])
	p.y = 0
	self.moveAmt:add(p)
	bludG.camera.scroll:sub(p)
end
function WorldSelectMenu:addTopBar(description, backPress, backName)
	local o = self
	local backName = backName or 'back'
	
	local tb = o:add(Object(0,0,bludG.camera.w, 35*r_scale))
	tb.sprite = sprites['ui']['white.png']
	tb.drawType = 'stretched'
	tb.sheet = sheets['ui']
	tb:setColor(209, 207, 199)
	tb.scrollFactor = Vec2(0,0)

	local drop = o:add(Object(0,35*r_scale,bludG.camera.w, 2*r_scale))
	drop.sprite = sprites['ui']['white.png']
	drop.drawType = 'stretched'
	drop.sheet = sheets['ui']
	drop:setColor(0,0,0,100)
	drop.scrollFactor = Vec2(0,0)

	if backPress then
		tb = o:add(TiltedRect(0,0,100*r_scale, 35*r_scale))
		tb.sprite = sprites['ui']['white.png']
		tb.drawType = 'stretched'
		tb.sheet = sheets['ui']
		tb:setColor(147,146,140)
		tb.touchDown = CameraButton.touchDown
		tb.touchUp = CameraButton.touchUp
		tb.onPress = backPress
		tb.scrollFactor = Vec2(0,0)

		local backText = o:add(StringObject(0,0, backName, nil, 0.5))
		backText:setColor(255, 255, 255)
		backText:setPosition(tb.w/2-backText.w*0.75, tb.h/2-backText.h/2)
		backText:setScrollFactor(Vec2(0,0))
	end
	local descriptionText = o:add(StringObject(0,0, description, nil, 0.5))
	descriptionText:setColor(0,0,0)
	descriptionText:setPosition(bludG.camera.w-descriptionText.w-40, tb.h/2-descriptionText.h/2)
	descriptionText:setScrollFactor(Vec2(0,0))
	
end
function WorldSelectMenu:addTri(fc, count, world, onPress)
	local o = self
	local t = o.tris:add(TriangleObject(fc.x+10*r_scale, fc.y+5*r_scale))
	t:setSize(o.tsize+5*r_scale)
	t:setRot(self.rotOff)
	t:setColor(0,0,0)
	t = o.tris:add(TriangleObject(fc.x, fc.y))
	t:setSize(o.tsize)
	t:setRot(self.rotOff)
	t:setColor(world[2][1], world[2][2], world[2][3])
	t.st = o:add(StringObject(fc.x, fc.y+50*r_scale, world[1], nil, 0.5))
	t.st:setColor(0,0,0)
	t.st:setPosition(fc.x-t.st.w/2, fc.y+50*r_scale)
	t.onPress = onPress
end
-- mainState = WrapperState(Group());
-- mainState:changeState(WorldSelectMenu())
