local sheets = {
	{name="ui", t='png'},
	{name="bg", t='png', extrude=0, padding=0, shapePadding=0, borderPadding=0, premultiplyAlpha=""},
	{name="additive", t='png'},
}

for i, v in ipairs(sheets) do
	local extension = 'png'
	local padding = v.padding or 2
	local extrude = v.extrude or 1
	local premultiplyAlpha = v.premultiplyAlpha or ' --premultiply-alpha '
	local shapePadding = v.shapePadding or "2"
	shapePadding = " --shape-padding " .. shapePadding .. " "
	
	local borderPadding = v.borderPadding or "2"
	borderPadding = " --border-padding " .. borderPadding .. " "

	local opt = '--extrude ' .. extrude .. ' ' .. shapePadding .. borderPadding .. premultiplyAlpha
	-- opt = '--extrude 1 '
	if v.t == 'pvr' then
		extension = 'pvr'
		opt = '--opt PVRTC4 --padding '.. padding ..' --premultiply-alpha --heuristic-mask --reduce-border-artifacts '
		opt = '--opt PVRTC4 --padding '.. padding ..' --heuristic-mask --reduce-border-artifacts '
	end

	local retina = "TexturePacker " .. opt .. "--trim --format corona --data ../world_packs/basic/" .. v.name .. "_list-hd.lua --algorithm MaxRects --maxrects-heuristics best --verbose --sheet ../world_packs/basic/" .. v.name .. "@2x." .. extension .." ../../../ungrouped_sprites/".. v.name .. "/*;"
	local non_retina = "TexturePacker " .. opt .. "--trim --format corona --data ../world_packs/basic/" .. v.name .. "_list.lua --algorithm MaxRects --maxrects-heuristics best --verbose --scale 0.5 --sheet ../world_packs/basic/" .. v.name .. "." .. extension .." ../../../ungrouped_sprites/".. v.name .. "/*;"
	os.execute(retina)
	os.execute(non_retina)
	
end

-- sed -i"" "/module/d" cute_list.lua;
-- sed -i"" "/module/d" cute_list-hd.lua;